require 'default:base_crafting_controller'

function ShowCraftingMenu(createdObject,isImproving,canImprove,improveResultString,improveString)
	isImproving = false
	if (this:HasTimer("CraftingTimer")) then return end
	if (this:HasTimer("AutoCraftItem")) then return end
	if (mAutoCraft == true) then mAutoCraft = false end
	if not(RecipeCategories[mSkill]) then
		--DebugMessage("ERROR: Crafting menu for skill with no recipes! "..tostring(mSkill) )
		return
	end

	this:RemoveTimer("RemoveCraftingModule")
	--save it to an obj var so players can come back and not have to select the quality again.
	mCurrentTab = mCurrentTab or "Materials"
	skillName = mSkill
	local subCategoryTable = {}
	for i,j in pairs(RecipeCategories[skillName]) do
		if (j.Name == mCurrentTab) then
			subCategoryTable = j.Subcategories
			break
		end
	end
	--DebugMessage(mCurrentTab)
	--DebugMessage(mCurrentCategory)
	--DebugMessage(DumpTable(subCategoryTable))
	if (mCurrentCategory == nil) then
		for i,j in pairs(subCategoryTable) do
			mCurrentCategory = j[1]
			break
		end
	end
	--DebugMessage(mCurrentCategory)
	--DebugMessage("mCurrentCategory is "..tostring(mCurrentCategory))
	--DebugMessage("mCurrentTab is " .. tostring(mCurrentTab))	
	local mainWindow = DynamicWindow("CraftingWindow",StripColorFromString(mTool:GetName()),805,510,-410,-280,"","Center")
	local numCategories = CountTable(RecipeCategories[skillName])

	local buttons = {}
	for i,j in pairs(RecipeCategories[skillName]) do
		table.insert(buttons,{Text = j.Name})
	end

	AddTabMenu(mainWindow,
	{
        ActiveTab = mCurrentTab, 
        Buttons = buttons
    })	
		
	--Add the images for each sub window
	mainWindow:AddImage(0,37-9,"BasicWindow_Panel",94,437,"Sliced")
	mainWindow:AddImage(95,37-9,"BasicWindow_Panel",210,437,"Sliced")
	mainWindow:AddImage(306,37-9,"BasicWindow_Panel",478,437,"Sliced")
	--Next create 2 scroll windows.

	--One for subcategories
	local subCategories = ScrollWindow(3,43-9,78,426,69) --423 not 430?
	--add all the sub categories for that category
	--DebugMessage(DumpTable(RecipeCategories[skillName][mCurrentTab]))
	local categories = {}
	for i,j in pairs(subCategoryTable) do 
		categories[i] = j
	end
	for i,j in pairs(categories) do
		newElement = ScrollElement()
		local selected = "default"
		if (mCurrentCategory == j[1]) then
			selected = "pressed"
		end
		local subCatDisplayName = j[2] or j[1]
		local subCatIconName = j[3] or j[1]
		newElement:AddButton(3,3,"ChangeSubcategory|"..tostring(j[1]),"",64,64,tostring(subCatDisplayName),"",false,"List",selected)
		newElement:AddImage(3,3,"CraftingCategory_"..tostring(subCatIconName),0,0)
		
		subCategories:Add(newElement)
	end
	--One for actual recipes
	local recipeList = ScrollWindow(94,36,196,426,26)
		--add all the recipes for that category

	--first sort the recipes
	local recipes = {}
	for i,j in pairs(AllRecipes[skillName]) do 
		if (j.Category == mCurrentTab and j.Subcategory == mCurrentCategory) then
			j.Name = i
			table.insert(recipes,j)
		end
	end
	table.sort(recipes,function (a,b)
		if (a.MinLevelToCraft < b.MinLevelToCraft) then
			return true
		else
			return false
		end
	end)

	if (mRecipe == nil and #recipes > 0) then
		mRecipe = recipes[1].Name		
	end
	--DebugMessage("mRecipe is " .. tostring(mRecipe))

	--add the recipes
	local hasRecipes = false
	for i,j in pairs(recipes) do
		newElement = ScrollElement()
		local selected = "default"
		if (mRecipe == j.Name) then selected = "pressed" end
		--DebugMessage(j.Category," is category")
		--Checking for guild faction recipes

		local showRecipe = true
		if (showRecipe) then
			if (HasRecipe(this,j.Name)) then
				newElement:AddButton(6,0,"ChangeRecipe|"..tostring(j.Name),"",178,26,"Recipe for a "..j.DisplayName,"",false,"List",selected)
				newElement:AddLabel(22,6,j.DisplayName,155,30,16,"",false,false,"")
			else
				newElement:AddButton(6,0,"ChangeRecipe|"..tostring(j.Name),"",178,26,"Recipe for a "..j.DisplayName.."\n[D70000]You have not learned this recipe[-]","",false,"List",selected)
				newElement:AddLabel(22,6,"[999999]"..j.DisplayName.."[-]",155,30,16,"",false,false,"")
			end
			hasRecipes = true
			--DebugMessage("it should be added")
			recipeList:Add(newElement)
		end
	end
	mainWindow:AddScrollWindow(subCategories)
	if (hasRecipes) then
		mainWindow:AddScrollWindow(recipeList)
	end
	newElement = nil
	--create the craft window
	if (mRecipe ~= nil and mRecipe ~= "None" and skillName ~= nil) then
		--(skillName,mRecipe)
		--DebugMessage("mRecipe is "..mRecipe)
		local recipeTable = AllRecipes[skillName][mRecipe]
		if(recipeTable == nil) then
			DebugMessage("ERROR: Attempted to display recipe that is missing recipe table entry. " .. tostring(mRecipe))
		else

			-- verify the material for the given recipe
			if ( recipeTable.CanImprove ) then
				local first = nil
				local found = false
				for i=1,#MaterialIndex[skillName] do
					if ( recipeTable.Resources[MaterialIndex[skillName][i]] ~= nil ) then
						--DebugMessage(recipeTable.Resources[MaterialIndex[skillName][i]])
						if ( first == nil ) then first = MaterialIndex[skillName][i] end
						if ( mCurrentMaterial == MaterialIndex[skillName][i] ) then
							found = true
						end
					end
				end
				if not( found ) then
					mCurrentMaterial = first
				end
			else
				mCurrentMaterial = nil
			end

			--DebugMessage("Current Material ", mCurrentMaterial)

			--DebugMessage("Getting here")
		    --Add the portrait
			mainWindow:AddImage(314,38,"DropHeaderBackground",100,100,"Sliced")
			--DebugMessage(Materials[mCurrentMaterial])
			local templateData = GetTemplateData(recipeTable.CraftingTemplateFile)
			mainWindow:AddImage(319,43,tostring(templateData.ClientId),90,90,"Object",nil,Materials[mCurrentMaterial] or templateData.Hue or 0)
			if(recipeTable.StackCount) then
				mainWindow:AddLabel(385,105,tostring(recipeTable.StackCount),350,26,26)
			end

			local Description = GetCraftingDescription(recipeTable.CraftingTemplateFile,recipeTable)

		    --add the craft button
		    local reason = ""
			local craftText = "Craft"
			local craftAllText = "Craft All"
			local enableCraft = "default"
			if (not CanCraftItem(mRecipe)) then
				craftText = "[555555]Craft[-]"
				craftAllText = "[555555]Craft All[-]"
				enableCraft = "disabled"
				reason = "[D70000]"..CannotCraftReason(mRecipe).."[-]"
			end
			if (not HasRequiredCraftingSkill(this,mRecipe,mSkill) ) then
				skillColor = "[D70000]"
			else
				skillColor = ""
			end
			--DebugMessage("i is "..tostring(i))		
			local skillReq, maxSkill = GetRecipeSkillRequired(mRecipe,mCurrentMaterial)
			local minSkillLabel = skillColor.."Minimum Skill: " ..tostring(math.max(0, skillReq)) .. "[-]"

			--mainWindow:AddButton(489,422-9,mRecipe,craftText,120,0,"Craft this item.","",true,"",enableCraft)
			mainWindow:AddButton(489,422-9,"CraftAll","Craft",120,0,"Craft this item until you run out of resources.","",true,"",enableCraft)
			mainWindow:AddLabel(489-150,420,"[A1ADCC]How many: [-]",460,70,18)
			mainWindow:AddTextField(489-75,418,60,20,"quantity", "1")

			--
			--add the cannot craft message if you can't craft it=
			local recipeTitle = GetRecipeItemName(recipeTable,mCurrentMaterial) or (recipeTable.DisplayName)
			if(recipeTable.StackCount) then
				recipeTitle = recipeTitle .. " x "..tostring(recipeTable.StackCount)
			end
			mainWindow:AddLabel(424,46-9,recipeTitle,350,26,26)
			--Add the label
			mainWindow:AddLabel(633,421-9,reason,150,0,16,"",false,false,"PermianSlabSerif_16_Dynamic")
			--Add the min skill
			mainWindow:AddLabel(420-16+20,68-12+10+6-9,minSkillLabel,200,20,16,"",false,false,"PermianSlabSerif_16_Dynamic")
			
			local reqSkillLev, maxSkillLev = GetRecipeSkillRequired(mRecipe,mCurrentMaterial)
			mSkillLevel = GetSkillLevel(this,mSkill)
			local chance = SkillValueMinMax(mSkillLevel, reqSkillLev, maxSkillLev)
			chance = math.floor(math.max(0, math.min(100,chance*100)))
			if( chance < 1 and chance > 0 ) then chance = 1 end
			--mainWindow:AddLabel(314,158-9,"[A1ADCC]Success Chance: [-]"..tostring(chance).."%",460,70,18)

			if(Description) then
				if (type(Description) == "string") then
					mainWindow:AddLabel(314,148,"[A1ADCC]Description: [-]"..Description,460,70,18)
				elseif type(Description) == "table" then
					mainWindow:AddLabel(314,148,"[A1ADCC]Description: [-]"..Description[1],460,70,18)
				else
					DebugMessage("[base_crafting_controller|DisplayItem] ERROR: Crafting description is not string or table. This should never happen.")
				end	
			end
			--add the section bars
			mainWindow:AddImage(419+7,145-9,"Divider",360-14,0,"Sliced")
			mainWindow:AddImage(309+6,323-9,"Divider",470-12,0,"Sliced") --
			--Add the quality levels

			if ( recipeTable.CanImprove ) then
				local index = 0
				local count = 0
				for i=1,#MaterialIndex[skillName] do
					if ( recipeTable.Resources[MaterialIndex[skillName][i]] ~= nil ) then
						if ( MaterialIndex[skillName][i] == mCurrentMaterial ) then
							index = count
						end
						count = count + 1
						local resourceTable = GetQualityResourceTable(recipeTable.Resources, MaterialIndex[skillName][i])
						if ( resourceTable ~= nil ) then
							--DebugMessage(resourceTable)
							userActionData = GetDisplayItemActionData(mRecipe,recipeTable,MaterialIndex[skillName][i])
							--DebugMessage(userActionData)
							mainWindow:AddUserAction(374+(50*count),88,userActionData,40)
						end
					end
				end
				mainWindow:AddImage(420+(50*index),85,"CraftingWindowWeaponTypeHighlight",47,47)
			else
				local userActionData = GetDisplayItemActionData(mRecipe,recipeTable)
				mainWindow:AddUserAction(424,88,userActionData,40)
			end

			-- Add the trivial tag if necesary
			-- if(GetSkillLevel(this,mSkill) >= maxSkill) then
			-- 	mainWindow:AddImage(670,40,"DropHeaderBackground",100,25,"Sliced")
			-- 	mainWindow:AddLabel(720,46,"[DAA520]Trivial[-]",50,0,18,"center",false,false)
			-- 	mainWindow:AddButton(670,40,"","",100,25,"[$1632]","",false,"Invisible")
			-- end

			--Add the resources required
			-----------------------------------------------------------------------------------------------------------
			local qualityResourceTable = GetQualityResourceTable(recipeTable.Resources,mCurrentMaterial)

			if ( qualityResourceTable == nil ) then
				LuaDebugCallStack("Nil qualityResource Table for recipe "..recipeTable.DisplayName.." current material: "..mCurrentMaterial)
				return
			end

			--calculate the total size of the resources required section
			local SIZE_PER_RESOURCE = 50
			local resourceSectionSize = CountTable(qualityResourceTable)
			--set the starting position to be the size/2
			local resourceStartLocation = 530 - 8 - ((resourceSectionSize*SIZE_PER_RESOURCE)/2)+10
			local position = resourceStartLocation
			local count = 0
			--for each resource required
			for i,j in pairs(qualityResourceTable) do
				local myResources = CountResourcesInContainer(this:GetEquippedObject("Backpack"), i)
				local resourcesRequired = j
				local resultString =  myResources.. " / " .. resourcesRequired
				--get the resources required
				--count the resources the player has
				local resourceTemplate = GetResourceTemplateId(i)
				if(resourceTemplate ~= nil) then
					local tooltipString = "You need " ..tostring(resourcesRequired - myResources).." more "..GetResourceDisplayName(i)
					if (myResources >= resourcesRequired) then
						tooltipString = "You'll need to use "..tostring(resourcesRequired).. " "..GetResourceDisplayName(i).." to craft this. You have "..tostring(myResources).."."
					end
					--add the image highlighted if you have the resource
					local resourceHue = nil
					if (HasResources(recipeTable.Resources, this, mCurrentMaterial)) then
						mainWindow:AddImage(resourceStartLocation+(SIZE_PER_RESOURCE)*(count)+20,345-9,"CraftingItemsFrame",38,38)
					else
						mainWindow:AddImage(resourceStartLocation+(SIZE_PER_RESOURCE)*(count)+20,345-9,"CraftingNoItemsFrame",38,38)
						resourceHue = "AAAAAA"
					end
					--invisible button that does a tooltip
					mainWindow:AddButton(resourceStartLocation+(SIZE_PER_RESOURCE)*(count)+20,345-9,"","",38,38,tooltipString,"",false,"Invisible")
					--add the icon
					mainWindow:AddImage(resourceStartLocation+(SIZE_PER_RESOURCE)*(count)+23,348-9,tostring(GetTemplateIconId(resourceTemplate)),32,32,"Object",resourceHue,Materials[mCurrentMaterial] or 0)
					--display it red if they don't have it
					if (myResources < resourcesRequired) then
						resultString = "[D70000]" .. resultString .. "[-]"
					end
					--add the label
					mainWindow:AddLabel(resourceStartLocation+(SIZE_PER_RESOURCE)*(count)+42,390-9,resultString,50,20,16,"center",false,false,"PermianSlabSerif_16_Dynamic")
					count = count + 1
				else
					DebugMessage("ERROR: Recipe has invalid ingredient resource. "..tostring(mRecipe))
				end
			end
		end
	----------------IMPROVEMENT WINDOW---------------------------
	elseif (createdObject ~= nil or isImproving) then
		local recipeTable = AllRecipes[skillName][mRecipe]
		--Add the label 
		--DebugMessage("mQuality is " ..tostring(mQuality))
		local countString = ""
		if (mCount) > 1 then
			countString = mCount .. " "
		end
		local resultLabel = improveResultString or ("You have crafted: "..countString..tostring(GetRecipeItemName(recipeTable,mQuality)))
			--if the label isn't specified

		--Add the bars
		--add the description (if it's not destroyed)
		local Description = GetCraftingDescription(recipeTable.CraftingTemplateFile,recipeTable,createdObject)
		
		mainWindow:AddImage(498,46+25-9,"ObjectPictureFrame",100,100,"Sliced")
		mainWindow:AddImage(520,61+25-9,tostring(GetTemplateIconId(recipeTable.CraftingTemplateFile)),64,64,"Object")
		mainWindow:AddLabel(550,181-9,resultLabel,490,40,24,"center")
		mainWindow:AddImage(309+6,214-9,"Divider",470-12,0,"Sliced") --
		if (canImprove) then
			mainWindow:AddImage(309+6,309-9,"Divider",470-12,0,"Sliced") --
		end

		if (canImprove and Description) then
			if (type(Description) == "string") then
				mainWindow:AddLabel(309,158-9,Description,460,70,16)
			--scrollElement:AddLabel(215,30,"Description: "..Description,330,60,15
			--Add the description)
			elseif type(Description) == "table" then
				--DebugMessage(DumpTable(Description))
				--Add the bonuses if applicable
				mainWindow:AddLabel(403,248-6-9,Description[2],200,70,16)
				mainWindow:AddLabel(564,248-6-9,Description[3],200,70,16)
			else
				DebugMessage("[base_crafting_controller|DisplayItem] ERROR: Crafting description is not string or table. This should never happen.")
			end	
		end
		if (createdObject ~= nil and recipeTable.CanImprove) then
		--if it's improving 
			local improveLabel = improveString
			mainWindow:AddLabel(545,335-9,improveLabel,500,30,22,"center")
			--add the chance to break or improve
			local improvementString = ""
			if (mImprovementGuarantees > 0) then
				improvementString = "\n[F7CC0A]"..tostring(mImprovementGuarantees).." Improvements Remaining[-]"		 
			else		
				improvementString = improvementString .."\n[009715]"..math.floor(GetImprovementChance()).."% Chance to Improve Item[-]"
				improvementString = improvementString .."\n[FA0C0C]"..math.floor(GetBreakChance()).."% Chance to Break Item[-]"
			end
			mainWindow:AddLabel(545,360-15-9,improvementString,200,50,16,"center")
			--add the improve button
			mainWindow:AddButton(416,425-9,"Improve","Improve",120,30,"[$1633]","",true)
			--add the cancel button
			mainWindow:AddButton(565,425-9,"Cancel","Cancel",120,30,"Don't improve the item.","",false)
		--otherwise 
		else
			mainWindow:AddButton(489,422-9,"OK","OK",120,30,"Return to the crafting menu.","",false)
		end
			--label--display the OK button
	else
		--This should never happen
		mainWindow:AddLabel(560,50-9,"Select a recipe for details.",150,20,16,"center")
	end
	mQuality = nil
	this:OpenDynamicWindow(mainWindow,this)

	--this:ScheduleTimerDelay(TimeSpan.FromSeconds(60),"RemoveCraftingModule")
end