require 'default:base_magic_sys'

function GetSpellHealAmount(spellName, spellSource)
	Verbose("Magic", "GetSpellHealAmount", spellName, spellSource)
    if(spellSource == nil) then spellSource = this end
	
	--DebugMessage( "scrollObj", mScrollObj )

	local healAmount = 0
	local magicSkill = GetSkillLevel(spellSource,SpellData.AllSpells[spellName].Skill)

	-- If they are using a scroll we want to aleast give them half the benefits of the scroll 
	-- if they don't have higher magery skill.
	if( mScrollObj ) then
		magicSkill = math.max( magicSkill, ServerSettings.Combat.ScrollBaseMagerySkill )
	end

	if(spellName == "Heal") then
		healAmount = (magicSkill / 7.5) + (math.floor(math.random(1, 3) + 0.5))
	elseif(spellName == "Greaterheal") then
		healAmount = (magicSkill * 0.4) + (math.floor(math.random(1, 10) + 0.5))
	else
		DebugMessage("Unknown healing spell "..spellName)
		return 0
	end
	--round to nearest int
	healAmount = math.floor(healAmount + 0.5)

	return healAmount * 2
end

function TryExecuteCastEnchant( mobileObj )
	
	local enchants = EnchantingHelper.GetUniqueEquipmentEnchants(_Weapon, _Armor)

	--DebugTable( CombatMod )

	for enchant,data in pairs(enchants) do 

		-- If this isn't swing proc'd, or we don't have a mobile mod then we need to leave!
		if( data.CastProc and CombatMod[data.MobileMod] ) then
			local range = data.EffectRangeMax or 0
			local successChance = (math.min(GetCombatMod(CombatMod[data.MobileMod], 0), range)/100)
			
			--DebugMessage("Success: " .. tostring(successChance))
			local success = Success(successChance)

			-- Proc mobile effect on swing!
			if( success ) then
				-- Mobile Effect
				if( data.MobileEffect and HasMobileEffect(this, data.MobileEffect) == false or data.MobieEffectCanStack == true ) then
					StartMobileEffect(
						this, 
						data.MobileEffect, 
						nil, 
						{ 
							Duration = data.MobileEffectDuration or nil, 
						} 
					)
				end

			end

		end

	end
	
	return true
end