require 'default:base_mobilestats'

function RecalculateMaxHealth()
	local isPlayer = IsPlayerCharacter(this)
	local baseHealth = this:GetObjVar("BaseHealth")
	local finalHealthPlus = 0
	if(baseHealth == nil) then
		if(isPlayer) then
			baseHealth = 150
		else
			baseHealth = 150
		end
	end
	
	if (isPlayer) then
		local totalSkillsGained = GetSkillTotal(this,(this:GetObjVar("SkillDictionary") or {}))
		local percent = totalSkillsGained / ServerSettings.Skills.PlayerSkillCap.Total
		finalHealthPlus = math.ceil(percent*200)
	end


	local maxHealth = (baseHealth + finalHealthPlus + GetMobileMod(MobileMod.MaxHealthPlus)) * GetMobileMod(MobileMod.MaxHealthTimes, 1)


	--this:NpcSpeech("MaxHP: "..tostring(maxHealth).." : ("..tostring(baseHealth).."*"..tostring(GetMobileMod(MobileMod.MaxHealthTimes, 1))..")")
	this:SetStatMaxValue("Health", math.floor(maxHealth))
end

function RecalculateManaRegen()
	local manaRegen = this:GetObjVar("ManaRegen")
	if not( manaRegen ) then
		if ( IsPlayerCharacter(this) ) then
			manaRegen = ServerSettings.Stats.BaseManaRegenRate
		else
			manaRegen = ServerSettings.Stats.DefaultMobManaRegen
		end
	end
	this:SetStatRegenRate("Mana", (manaRegen + GetMobileMod(MobileMod.ManaRegenPlus)) * GetMobileMod(MobileMod.ManaRegenTimes, 1) )
end

function RecalculateMaxMana()
	this:SetStatMaxValue("Mana", math.floor(((GetInt(this)*4) + GetMobileMod(MobileMod.MaxManaPlus)) *GetMobileMod(MobileMod.MaxManaTimes, 1)) )
end

function RecalculateMaxStamina()
	this:SetStatMaxValue("Stamina", math.floor(((ServerSettings.Stats.BaseStamina + (GetAgi(this)  * 4) + GetMobileMod(MobileMod.MaxStaminaPlus)) *GetMobileMod(MobileMod.MaxStaminaTimes, 1)) ) )
end

function RecalculateMaxWeight()
	local backpack = this:GetEquippedObject("Backpack")
	if ( backpack ~= nil ) then
		local base = 80
		if ( IsPlayerCharacter(this) ) then
			local weight = (base + GetStr(this) * 2 + GetMobileMod(MobileMod.MaxWeightPlus)) * GetMobileMod(MobileMod.MaxWeightTimes, 1)
			backpack:SetSharedObjectProperty("MaxWeight", weight)
		else
			if ( backpack:HasObjectTag("HorseBackpack") ) then
				backpack:SetSharedObjectProperty("MaxWeight", base * 2)
			end
		end
	end
end

function RecalculateAttack()
	local isPlayer = IsPlayerCharacter(this)
	--start with attack from objvar if it exists
	local attack = 0
	if(isPlayer) then
		attack = this:GetObjVar("Attack") or 0
        --if unarmed, use brawling attack
        if not (_Weapon and _Weapon.RightHand.Object) then
            attack = 4
        --start with equipped weapon's base attack for that weapon TYPE if available
        else
            attack = EquipmentStats.BaseWeaponStats[_Weapon.RightHand.Type].Attack or 0
        end
        --adjust attack for stats, skills, weapon attack bonus, mobile mod
        local itemAttackModifier = GetMobileMod(MobileMod.AttackBonus) or 0
        local strModifier = (GetStr(this)/5) or 0
        local tacticsBonus = (GetSkillLevel(this, "TacticsSkill")/ 20) or 0

        attack = attack + itemAttackModifier + strModifier + tacticsBonus

    else
		attack = this:GetObjVar("Attack") or ServerSettings.Stats.DefaultMobAttack or 0
    end

	attack = math.floor((attack + GetMobileMod(MobileMod.AttackPlus)) * GetMobileMod(MobileMod.AttackTimes, 1))

	CallFunctionDelayed(TimeSpan.FromMilliseconds(150),function() this:SetStatValue("Attack", attack) end)
	this:SetStatValue("Attack", attack)
end

