-- user interface information
RecipeCategories.WoodsmithSkill = 
{
	{
		Name = "Weapons",
		Subcategories = {
			{"Bows","Bows","Ranged"},
			{"Arrows","Arrows","Ranged"},
		},
	},	
}

AllRecipes.WoodsmithSkill.ShortBow = 
{
	MinLevelToCraft = CraftingDifficulty.VeryEasy.Min,
	MaxLevelToGain = CraftingDifficulty.VeryEasy.Max,
	DisplayName = "Short Bow",
	CraftingTemplateFile = "weapon_shortbow",
	ItemType = "WeaponClass",
	Description = "A Short Bow. This is a apprentice weapon.",
	CanImprove = true,
	Category = "Weapons",
	Subcategory = "Bows",
	NeedRecipe = true,
	EnableCraftOrder = true,
	Resources = 
	{
		Boards = { Boards = 1 },
		AshBoards = { AshBoards = 1 },
		BlightwoodBoards = { BlightwoodBoards = 1 },
	},
}
AllRecipes.WoodsmithSkill.LongBow = 
{
	MinLevelToCraft = CraftingDifficulty.Normal.Min,
	MaxLevelToGain = CraftingDifficulty.Normal.Max,
	DisplayName = "Long Bow",
	CraftingTemplateFile = "weapon_longbow",
	ItemType = "WeaponClass",
	Description = "A Long Bow. This is a rookie weapon.",
	CanImprove = true,
	Category = "Weapons",
	Subcategory = "Bows",
	NeedRecipe = true,
	EnableCraftOrder = true,
	Resources = 
	{
		Boards = { Boards = 2 },
		AshBoards = { AshBoards = 2 },
		BlightwoodBoards = { BlightwoodBoards = 2 },
	},
}
AllRecipes.WoodsmithSkill.WarBow = 
{
	MinLevelToCraft = CraftingDifficulty.VeryHard.Min,
	MaxLevelToGain = CraftingDifficulty.VeryHard.Max,
	DisplayName = "War Bow",
	CraftingTemplateFile = "weapon_warbow",
	ItemType = "WeaponClass",
	Description = "A War Bow. This is a journeyman weapon.",
	CanImprove = true,
	Category = "Weapons",
	Subcategory = "Bows",
	NeedRecipe = true,
	EnableCraftOrder = true,
	Resources = 
	{
		Boards = { Boards = 3 },
		AshBoards = { AshBoards = 3 },
		BlightwoodBoards = { BlightwoodBoards = 3 },
	},
}


-- arrow recipes
AllRecipes.WoodsmithSkill.Arrow = 
{
	MinLevelToCraft = CraftingDifficulty.Easy.Min,
	MaxLevelToGain = CraftingDifficulty.Easy.Max,
	DisplayName = "Arrow",
	CraftingTemplateFile = "arrow",
	Description = "arrows crafted from normal boards",
	NeedRecipe = false,
	CanImprove = false,
	Category = "Weapons",
	Subcategory = "Arrows",
	EnableCraftOrder = true,
	StackCount = 40,
	Resources = 
	{
		Boards = 1,
	},
}
AllRecipes.WoodsmithSkill.AshArrows = 
{
	MinLevelToCraft = 45,
	MaxLevelToGain = 55,
	DisplayName = "Ash Arrow",
	CraftingTemplateFile = "arrow_ash",
	Description = "arrows crafted from ash boards",
	NeedRecipe = true,
	CanImprove = false,
	Category = "Weapons",
	Subcategory = "Arrows",
	StackCount = 40,
	Resources = 
	{
		AshBoards = 1,
	},
}
AllRecipes.WoodsmithSkill.BlightwoodArrows = 
{
	MinLevelToCraft = 65,
	MaxLevelToGain = 75,
	DisplayName = "Blightwood Arrow",
	CraftingTemplateFile = "arrow_blightwood",
	Description = "arrows crafted from blightwood boards",
	NeedRecipe = true,
	CanImprove = false,
	Category = "Weapons",
	Subcategory = "Arrows",
	StackCount = 40,
	Resources = 
	{
		BlightwoodBoards = 1,
	},
}

