-- user interface information
RecipeCategories.FabricationSkill = 
{
	{
		Name = "Armor",
		Subcategories = {
			{"Head",},
			{"Legs",},
			{"Torso",},
		},
	},
    {
		Name = "Items",
		Subcategories = {
			{"Tools","Tools","Tools"},
			{"Containers","Containers","Storage"},
		},
	},
}

-- item recipes
AllRecipes.FabricationSkill.Bandage = 
{
	MinLevelToCraft = CraftingDifficulty.Trivial.Min,
	MaxLevelToGain = CraftingDifficulty.Trivial.Max,
    DisplayName = "Bandage",
    CraftingTemplateFile = "bandage",
    Description = "A simple bandage to help heal your wounds.",
    ItemType = "ResourceClass",
    Category = "Items",
    Subcategory = "Tools",
    NeedRecipe = false,
    CanSalvage = false,
    StackCount = 20,
    Resources = 
    {
        Cloth = 1,
    },
}

AllRecipes.FabricationSkill.Pouch = 
{
	MinLevelToCraft = CraftingDifficulty.Easy.Min,
	MaxLevelToGain = CraftingDifficulty.Easy.Max,
	DisplayName = "Pouch",
	Description = "A small leather pouch.",
	NeedRecipe = false,
	CanImprove = false,
	CraftingTemplateFile = "pouch",
	Category = "Items",
	Subcategory = "Containers",
	EnableCraftOrder = true,
	Resources = 
	{
		Leather = 1,
	},
}


-- NO OTHER HATS
AllRecipes.FabricationSkill.Bandana = nil
AllRecipes.FabricationSkill.BanditHood = nil

-- wizard armor recipes
AllRecipes.FabricationSkill.WizardsHat = 
{
	MinLevelToCraft = CraftingDifficulty.VeryEasy.Min,
	MaxLevelToGain = CraftingDifficulty.VeryEasy.Max,
	DisplayName = "Mage Hat",
	Description = "To act like a wizard, you need to look like a wizard.",
	NeedRecipe = true,
	CanImprove = true,
	CraftingTemplateFile = "armor_wizards_hat",
	ItemType = "ArmorClass",
	Category = "Armor",
	Subcategory = "Head",
	EnableCraftOrder = true,
	Resources = 
	{	
		Cloth = { Cloth = 6 },
		QuiltedCloth = { QuiltedCloth = 6 },
		SilkCloth = { SilkCloth = 6 },
	},
}
AllRecipes.FabricationSkill.WizardsRobes = 
{
	MinLevelToCraft = CraftingDifficulty.Normal.Min,
	MaxLevelToGain = CraftingDifficulty.Normal.Max,
	DisplayName = "Wizard's Robe",
	Description = "An elegant wizards robe",
	NeedRecipe = true,
	CanImprove = true,
	CraftingTemplateFile = "armor_wizards_robe",
	ItemType = "ArmorClass",
	Category = "Armor",
	Subcategory = "Torso",
	EnableCraftOrder = true,
	Resources = 
	{	
		Cloth = { Cloth = 20 },
		QuiltedCloth = { QuiltedCloth = 20 },
		SilkCloth = { SilkCloth = 20 },
	},
}

-- padded armor recipes
AllRecipes.FabricationSkill.PaddedHelm = 
{
	MinLevelToCraft = CraftingDifficulty.VeryEasy.Min,
	MaxLevelToGain = CraftingDifficulty.VeryEasy.Max,
	DisplayName = "Padded Helm",
	Description = "A Padded Helm is a robe armor piece protecting a user's head.",
	NeedRecipe = true,
	CanImprove = true,
	CraftingTemplateFile = "armor_padded_helm",
	ItemType = "ArmorClass",
	Category = "Armor",
	Subcategory = "Head",
	EnableCraftOrder = true,
	Resources = 
	{
		Cloth = { Cloth = 10 },
		QuiltedCloth = { QuiltedCloth = 10 },
		SilkCloth = { SilkCloth = 10 },
	},
}
AllRecipes.FabricationSkill.PaddedLegs = 
{
	MinLevelToCraft = CraftingDifficulty.VeryEasy.Min,
	MaxLevelToGain = CraftingDifficulty.VeryEasy.Max,
	DisplayName = "Padded Legs",
	Description = "Padded Leggings are a robe armor piece protecting a user's lower body.",
	NeedRecipe = true,
	CanImprove = true,
	CraftingTemplateFile = "armor_padded_leggings",
	ItemType = "ArmorClass",
	Category = "Armor",
	Subcategory = "Legs",
	EnableCraftOrder = true,
	Resources = 
	{
		Cloth = { Cloth = 15 },
		QuiltedCloth = { QuiltedCloth = 15 },
		SilkCloth = { SilkCloth = 15 },
	},
}
AllRecipes.FabricationSkill.PaddedChest = 
{
	MinLevelToCraft = CraftingDifficulty.VeryEasy.Min,
	MaxLevelToGain = CraftingDifficulty.VeryEasy.Max,
	DisplayName = "Padded Chest",
	Description = "A Padded Chest is a robe armor piece protecting a user's upper body.",
	NeedRecipe = true,
	CanImprove = true,
	CraftingTemplateFile = "armor_padded_tunic",
	ItemType = "ArmorClass",
	Category = "Armor",
	Subcategory = "Torso",
	EnableCraftOrder = true,
	Resources = 
	{
		Cloth = { Cloth = 15 },
		QuiltedCloth = { QuiltedCloth = 15 },
		SilkCloth = { SilkCloth = 15 },
	},
}

-- linen armor recipes
AllRecipes.FabricationSkill.LinenHelm = 
{
	MinLevelToCraft = CraftingDifficulty.Easy.Min,
	MaxLevelToGain = CraftingDifficulty.Easy.Max,
	DisplayName = "Linen Helm",
	Description = "A Linen Helm is a robe armor piece protecting a user's head.",
	NeedRecipe = true,
	CanImprove = true,
	CraftingTemplateFile = "armor_linen_helm",
	ItemType = "ArmorClass",
	Category = "Armor",
	Subcategory = "Head",
	EnableCraftOrder = true,
	Resources = 
	{
		Cloth = { Cloth = 10 },
		QuiltedCloth = { QuiltedCloth = 15 },
		SilkCloth = { SilkCloth = 15 },
	},
}
AllRecipes.FabricationSkill.LinenLegs = 
{
	MinLevelToCraft = CraftingDifficulty.Easy.Min,
	MaxLevelToGain = CraftingDifficulty.Easy.Max,
	DisplayName = "Linen Legs",
	Description = "Linen Leggings are a robe armor piece protecting a user's lower body.",
	NeedRecipe = true,
	CanImprove = true,
	CraftingTemplateFile = "armor_linen_leggings",
	ItemType = "ArmorClass",
	Category = "Armor",
	Subcategory = "Legs",
	EnableCraftOrder = true,
	Resources = 
	{
		Cloth = { Cloth = 15 },
		QuiltedCloth = { QuiltedCloth = 15 },
		SilkCloth = { SilkCloth = 15 },
	},
}
AllRecipes.FabricationSkill.LinenChest = 
{
	MinLevelToCraft = CraftingDifficulty.Easy.Min,
	MaxLevelToGain = CraftingDifficulty.Easy.Max,
	DisplayName = "Linen Chest",
	Description = "A Linen Chest is a robe armor piece protecting a user's upper body.",
	NeedRecipe = true,
	CanImprove = true,
	CraftingTemplateFile = "armor_linen_tunic",
	ItemType = "ArmorClass",
	Category = "Armor",
	Subcategory = "Torso",
	EnableCraftOrder = true,
	Resources = 
	{
		Cloth = { Cloth = 15 },
		QuiltedCloth = { QuiltedCloth = 15 },
		SilkCloth = { SilkCloth = 15 },
	},
}

-- leather armor recipes
AllRecipes.FabricationSkill.LeatherHelm = 
{
	MinLevelToCraft = CraftingDifficulty.Normal.Min,
	MaxLevelToGain = CraftingDifficulty.Normal.Max,
	DisplayName = "Leather Helm",
	Description = "A Leather Helm is a light armor piece protecting a user's head.",
	NeedRecipe = true,
	CanImprove = true,
	CraftingTemplateFile = "armor_leather_helm",
	ItemType = "ArmorClass",
	Category = "Armor",
	Subcategory = "Head",
	EnableCraftOrder = true,
	Resources = 
	{
		Leather = { Leather = 8 },
		BeastLeather = { BeastLeather = 8 },
		VileLeather = { VileLeather = 8 },
	},
}
AllRecipes.FabricationSkill.LeatherLegs = 
{
	MinLevelToCraft = CraftingDifficulty.Normal.Min,
	MaxLevelToGain = CraftingDifficulty.Normal.Max,
	DisplayName = "Leather Legs",
	Description = "Leather Leggings are a light armor piece protecting a user's lower body.",
	NeedRecipe = true,
	CanImprove = true,
	CraftingTemplateFile = "armor_leather_leggings",
	ItemType = "ArmorClass",
	Category = "Armor",
	Subcategory = "Legs",
	EnableCraftOrder = true,
	Resources = 
	{
		Leather = { Leather = 12 },
		BeastLeather = { BeastLeather = 12 },
		VileLeather = { VileLeather = 12 },
	},
}
AllRecipes.FabricationSkill.LeatherChest = 
{
	MinLevelToCraft = CraftingDifficulty.Normal.Min,
	MaxLevelToGain = CraftingDifficulty.Normal.Max,
	DisplayName = "Leather Chest",
	Description = "A Leather Chest is a light armor piece protecting a user's upper body.",
	NeedRecipe = true,
	CanImprove = true,
	CraftingTemplateFile = "armor_leather_chest",
	ItemType = "ArmorClass",
	Category = "Armor",
	Subcategory = "Torso",
	EnableCraftOrder = true,
	Resources = 
	{
		Leather = { Leather = 12 },
		BeastLeather = { BeastLeather = 12 },
		VileLeather = { VileLeather = 12 },
	},
}

-- hardened armor recipes		
AllRecipes.FabricationSkill.HardenedHood = 
{
	MinLevelToCraft = CraftingDifficulty.VeryHard.Min,
	MaxLevelToGain = CraftingDifficulty.VeryHard.Max,
	DisplayName = "Hardened Helm",
	Description = "A Hardened Leather Helm is a light armor piece protecting a user's head.",
	NeedRecipe = true,
	CanImprove = true,
	CraftingTemplateFile = "armor_hardened_helm",
	ItemType = "ArmorClass",
	Category = "Armor",
	Subcategory = "Head",
	EnableCraftOrder = true,
	Resources = 
	{
		Leather = { Leather = 8 },
		BeastLeather = { BeastLeather = 12 },
		VileLeather = { VileLeather = 12 },
	},
}
AllRecipes.FabricationSkill.HardenedLeggings = 
{
	MinLevelToCraft = CraftingDifficulty.VeryHard.Min,
	MaxLevelToGain = CraftingDifficulty.VeryHard.Max,
	DisplayName = "Hardened Leggings",
	Description = "Leather Leggings are a light armor piece protecting a user's lower body.",
	NeedRecipe = true,
	CanImprove = true,
	CraftingTemplateFile = "armor_hardened_leggings",
	ItemType = "ArmorClass",
	Category = "Armor",
	Subcategory = "Legs",
	EnableCraftOrder = true,
	Resources = 
	{
		Leather = { Leather = 12 },
		BeastLeather = { BeastLeather = 12 },
		VileLeather = { VileLeather = 12 },
	},
}
AllRecipes.FabricationSkill.HardenedChest = 
{
	MinLevelToCraft = CraftingDifficulty.VeryHard.Min,
	MaxLevelToGain = CraftingDifficulty.VeryHard.Max,
	DisplayName = "Hardened Chest",
	Description = "A Leather Chest is a light armor piece protecting a user's upper body.",
	NeedRecipe = true,
	CanImprove = true,
	CraftingTemplateFile = "armor_hardened_chest",
	ItemType = "ArmorClass",
	Category = "Armor",
	Subcategory = "Torso",
	EnableCraftOrder = true,
	Resources = 
	{
		Leather = { Leather = 12 },
		BeastLeather = { BeastLeather = 12 },
		VileLeather = { VileLeather = 12 },
	},
}

