function GetClipTarget()
	this:SystemMessage("target a object you want to clip to the clip board")
	this:RequestClientTargetGameObj(this, "targetToClip")
end

function HandleClipTarget(target,user)
	if(target==nil) then return end

	local clipString = ""
	local finalString = ""
	local template = target:GetCreationTemplateId()
	local location = target:GetLoc()
	local rotation = target:GetRotation()
	local scale = target:GetScale()
	local dynamicObjectElement = xml.new("DynamicObject")
    local creationParams = template .. " " .. 
                           location.X .. " " ..
                           location.Y .. " " ..
                           location.Z .. " " ..
                           rotation.X .. " " ..
                           rotation.Y .. " " ..
                           rotation.Z .. " " ..
                           scale.X .. " " ..
                           scale.Y .. " " ..
                           scale.Z
    -- add the objectcreationparams element and element data
    dynamicObjectElement:append("ObjectCreationParams")[1] = creationParams
    if(template == "simple_mob_spawner") then
    	local objVarOverridesElement = xml.new("ObjVarOverrides")
    	local spawnTemplateElement = xml.new("StringVariable")
		-- spawnTemplate
		spawnTemplateElement[1] = target:GetObjVar("SpawnerProfile")
		spawnTemplateElement["Name"] = "SpawnerProfile"
		objVarOverridesElement:append(spawnTemplateElement)

		dynamicObjectElement:append(objVarOverridesElement)
	end    

    clipString = string.gsub(tostring(dynamicObjectElement),"&quot;","\"")
    finalString = AddIndentX2(clipString)
	io.popen('clip','w'):write(finalString):close()
	user:SystemMessage("Object Cliped CTRL+V To Paste")
end

function AddIndentX2(str)
  local result = {}
  local finalResult = ""
  for line in str:gmatch '[^\n]+' do
    table.insert(result, line)
  end
  for k,v in pairs(result) do
  	finalResult = finalResult .. "\t\t"..v.."\n"
  end
  return finalResult
end

RegisterEventHandler(EventType.ClientTargetGameObjResponse, "targetToClip", HandleClipTarget)

RegisterCommand { Command="clip",Category="GizmosTools",AccessLevel=AccessLevel.God,Func=GetClipTarget,Usage="<clientids>", Desc="Copies the objects data and formats it then pastes it to the clip board. This allows you to paste in your <dynamicobject> element block in your seedobjects.xml file." }