ModsFolder = "C:/LoACore/PublicServer-1.4.1.7/StandAlone/mods/"

--- a function to grab all files listed in a given directory
--@param modName - (String) the mod folder to check
--@param folder - (String) the folder to look in
function GetAllFileNamesInDirectory(modName,folder,stripExtension) 
    stripExtension = stripExtension or true
    -- local table to insert the file names into
    local fileList = {}
    -- pop open a quick DOS dir command searching for these files
    -- use the /b to only show file name data
    -- use the /a-d to hide all sub directories
    for file in io.popen('dir "' .. ModsFolder .. modName .. '/'.. folder .. '" /b /a-d'):lines() do 
        -- insert all files that match into our fileList
        if(stripExtension == true) then          
            table.insert(fileList,string.sub(file,1,-5)) 
        else
            table.insert(fileList,file)             
        end
    end 
    -- return our populated file list table
    return fileList
end

--- a function to grab all sub folders listed in a given directory
--@param modName - (String) the mod folder to check
--@param folder - (String) the folder to look in
function GetAllFoldersInDirectory(modName,folder) 
    -- local table to insert the sub folder names into
    local folderList = {}
    -- pop open a quick DOS dir command searching for these files
    -- use the /b to only show file name data
    -- use the /ad to show only sub directories
    for file in io.popen('dir "' .. ModsFolder .. modName .. '/'.. folder .. '" /b /ad'):lines() do 
        -- insert all sub folders that match into our folderList
        table.insert(folderList,file) 
    end
    -- return our populated file list table
    return folderList
end


