function HandleModuleAttached()
	AddUseCase(this,"Spawn Dungeon",false,"IsGod")
	AddUseCase(this,"Destroy Dungeon",false,"IsGod")
	local dungeonData = initializer
	this:SetObjVar("DungeonData",dungeonData)
	-- due to random latency and the 1/4 sec check on scripts, delay 300ms no biggie on generation
	CallFunctionDelayed(TimeSpan.FromMilliseconds(300),function() GenerateDungeon(initializer) end)
end

function HandleDungeonTilePlaced(success,objRef,tileDataName,index)
	local dungeonData = this:GetObjVar("DungeonData")
	local tileData = GetTileDataByName(dungeonData[index])
	local rotation = tileData.Rotation
	objRef:SetObjVar("TileName",tileData.Name)
	objRef:SetObjVar("Index",index)
	objRef:SetRotation(rotation)
	local tileObjects = this:GetObjVar("TileObjects")
	table.insert(tileObjects,objRef)
	this:SetObjVar("TileObjects",tileObjects)
	objRef:SetObjVar("DungeonController",this)

	if(tileData.EndCaps) then
		AddRoomEndCaps(objRef,tileData)
	end
end

function HandleRoomConnectorCreated(success,roomConnector,adjustData)
	roomConnector:SetRotation(adjustData.Rotation)
	local endCapTable = this:GetObjVar("TileEndCapObjects")
	table.insert(endCapTable,roomConnector)
	this:SetObjVar("TileEndCapObjects",endCapTable)
end

function AddRoomEndCaps(dungeonController,tileData)
	for k,v in pairs(tileData.EndCaps) do
		-- if(tileData.Name == "Room 1 Exit - East") then
			local location = dungeonController:GetLoc()
			location.X = location.X + v.XOffset
			location.Y = location.Y + v.YOffset
			location.Z = location.Z - v.ZOffset
			CreateObj("tileset_bone_room_connector",location,"HandleRoomConnectorCreated",v)
		-- end		
	end	
end

function GenerateDungeon()
	local height = this:GetObjVar("Height")
	local width = this:GetObjVar("Width")
	local dungeonData = this:GetObjVar("DungeonData")
	this:SetObjVar("TileObjects",{})
	this:SetObjVar("TileEndCapObjects",{})
	local x = 1
	local y = 1 
	for index=1,(height*width) do
		local tileData = GetTileDataByName(dungeonData[index])
		if(x>width) then
			x=1
			y = y+ 1
		end
		local location = this:GetLoc()
		location.X = location.X + (15*x - 7.5)
		location.Z = location.Z + -(15*y - 7.5)
		if(dungeonData[index] == "Passage - Corner South") then
			location.X = location.X - 2.5
			location.Z = location.Z + 2.5
		end
		if(dungeonData[index] == "Passage - Corner West") then
			location.X = location.X + 2.5
			location.Z = location.Z + 2.5 
		end
		if(dungeonData[index] == "Passage - Corner North") then
			location.X = location.X + 2.5
			location.Z = location.Z - 2.5 
		end
		if(dungeonData[index] == "Passage - Corner East") then
			location.X = location.X - 2.5
			location.Z = location.Z - 2.5 
		end					
		CreateObj(tileData.Template, location, "HandleDungeonTilePlaced",tileData.Name,index,x,y)
		x = x + 1
	end
end

function HandleMessageUseObject(user,usedType)
	if(usedType == "Destroy Dungeon") then
		local tiles = this:GetObjVar("TileObjects")
		for k,v in pairs(tiles) do
			if(v) then
				v:Destroy()
			end
		end
		local tiles = this:GetObjVar("TileEndCapObjects")
		for k,v in pairs(tiles) do
			if(v) then
				v:Destroy()
			end
		end		
	end
	if(usedType == "Spawn Dungeon") then
		GenerateDungeon()
	end
end

RegisterEventHandler(EventType.CreatedObject, "HandleRoomConnectorCreated", HandleRoomConnectorCreated)
RegisterEventHandler(EventType.CreatedObject, "HandleDungeonTilePlaced", HandleDungeonTilePlaced)
RegisterEventHandler(EventType.ModuleAttached, GetCurrentModule(), HandleModuleAttached)
RegisterEventHandler(EventType.Message, "UseObject", HandleMessageUseObject)