function SaveDungeonToController(user)
	local dungeonEditorTable = user:GetObjVar("DungeonEditor")
	local dungeonTable = GetDungeonDataByName(user,dungeonEditorTable.SelectedDungeon)

	local directory = "mods/LoAExileEdition/dungeoneditor/controllers/"

	local xmlRoot = xml.new("ObjectTemplate")
	xmlRoot:append("Name")[1] = "[FF7700]Dungeon Controller[-]"
	xmlRoot:append("ClientId")[1] = 2 -- always a nodraw object
	xmlRoot:append("Color")[1] = "FF7700"

	--tooltip
	entry = xml.new("SharedStateEntry")
	entry["name"] = "TooltipString"
	entry["type"] = "string"
	entry["value"] = "[FF0000]".. dungeonTable.Name
	xmlRoot:append(entry)

	-- set up the object components	
	objectComponents = xml.new("ObjectVariableComponent") 

	--set up object variables
	entry = xml.new("DoubleVariable")
	entry["Name"] = "Height"
	entry[1] = dungeonTable.Height
	objectComponents:append(entry)

	entry = xml.new("DoubleVariable")
	entry["Name"] = "Width"
	entry[1] = dungeonTable.Width
	objectComponents:append(entry)

	xmlRoot:append(objectComponents)

	-- set up script engine components
	scriptEngineComponents = xml.new("ScriptEngineComponent")
	entry = xml.new("LuaModule")
	entry["Name"] = "dungeons.dungeon_controller"
	local initializer = xml.new("Initializer")
	initializer[1] = BuildDungeonInitializer(dungeonTable)
	entry:append(initializer)
	scriptEngineComponents:append(entry)
	xmlRoot:append(scriptEngineComponents)

	-- extract the &quote and replace with a "
	saveInfo = string.gsub(tostring(xmlRoot),"&quot;","\"")

	fileStream = io.open(directory..dungeonTable.Template..".xml","w")
	fileStream:write(saveInfo)
	fileStream:close()

	print(saveInfo)
end

function BuildDungeonInitializer(dungeonTable)
	local dungeonString = "\n\t\t\t{\n"
	for k,v in pairs(dungeonTable.DungeonData) do
		local appendString = "\""..v.."\",\n"
		dungeonString = dungeonString .. "\t\t\t\t" .. appendString
	end
	dungeonString = dungeonString .. "\n\t\t\t}\n\t\t\t"
	return dungeonString
end