---------------------------------------------------------------------------------------------------------
-- WEAPON CONTROL TABLES
---------------------------------------------------------------------------------------------------------
-- these weapon control tables allow a easier way to manage the control on how weapons feel and responed
-- by giving each attribute in the EquipmentStats.BaseWeaponStats table their own control table so it is
-- easier to define and can be added via item properties so players understand their weapon choices.
--
-- ** All the control tables are based off weapon speed, so if we want to add more we can. **
--
-- Current Weapon Speeds
-- *VerySlow
-- *Slow
-- *Normal
-- *Fast
-- *VeryFast
---------------------------------------------------------------------------------------------------------
-- controls the attack speed on weapons
---------------------------------------------------------------------------------------------------------
WeaponSpeed =
{
	VerySlow = 4,
	Slow = 3.5,
	Normal = 3,
	Fast = 2.5,
	VeryFast = 2,
}
---------------------------------------------------------------------------------------------------------
-- controls the base attack damage on weapons
---------------------------------------------------------------------------------------------------------
WeaponAttack =
{
	VerySlow = 16,
	Slow = 14,
	Normal = 12,
	Fast = 10,
	VeryFast = 8,
}
---------------------------------------------------------------------------------------------------------
-- controls the damage variance on weapons
---------------------------------------------------------------------------------------------------------
DamageVariance =
{
	VerySlow = 0.25,
	Slow = 0.2,
	Normal = 0.15,
	Fast = 0.1,
	VeryFast = 0.05,	
}