--=====================================================================
-- event object definitions
--=====================================================================
-- base object
TreasureHuntingEvent = {}
-- variable to hold the profile tables
TreasureHuntingEvent.EventProfiles = {}
-- variable to hold the object functions
TreasureHuntingEvent.Helpers = {}

--=====================================================================
-- EVENT PROFILES
--=====================================================================
TreasureHuntingEvent.EventProfiles.TheLanding =
{
	-- loot packs to add to the chest on template generation
	ChestLootPacks =
	{
		"CurrencyMed",
		"ClothArmorRecipes",
		"PotionsLow",
		"ReagentsMed",
	},	
	-- how long does the chest stay there till cleanup
	DecayTime = TimeSpan.FromHours(2),
	-- can this chest spawn monsters when opened for the first time?
	HasSpawnOnOpen = true,
	-- locations in which a chest can spawn
	Locations =
	{
		Loc2(-46.64,0,32.25),
		Loc2(-36.95,0,29.41),
		Loc2(-37.42,0,19.62),
		Loc2(-45.62,0,17.17),
		Loc2(-46.91,0,25.67),
	},
	-- profile name used for sorting alphabetically
	Name = "Upper Plains Treasure Hunt",
	-- the number of chest to spawn during this event
	NumberOfChestToSpawn = 5,
	-- the spawn information for what can spawn if HasSpawnOnOpen
	SpawnData = 
	{
		ChanceForRareSpawnReplacement = 0.1,
		Normal =
		{
			LootPacks = {"TreasureEventToken","TreasureEventLoot",},
			Templates = {"goblin","goblin_mage",},
			WipeSpawnInLootPacks = true,
		},
		NumberToSpawn = 4,
		Rare =
		{
			LootPacks = {"TreasureEventToken","TreasureEventLoot",},
			Templates = {"goblin_hq","goblin_mage_hq",},
			WipeSpawnInLootPacks = true,
		},
	},
	-- a list of chest objects to appear and fill with loot
	TreasureChestObjects =
	{
		{
			Template="your_chest_template",
			Name="Treasure Hunt Event Chest",
		},
		{
			Template="your_other_chest_template",
			Name="Treasure Hunt Event Chest",
		},		
	},
}