require 'default:globals.dynamic_window.hud'

--- OVERRIDE 
-- *needed to adjust how the region status dynamic window works
function UpdateRegionStatus(playerObj,areaName,curProtection)		
	areaName = areaName or GetRegionalName(playerObj:GetLoc())
	if(areaName == "TheLanding2") then areaName = "The Expanse" end
	local dynWindow = DynamicWindow("regionstatus","",0,0,-196,190,"Transparent","TopRight")
	
	--?? Find better way to examine the region area and display name properly
	dynWindow:AddLabel(100,0,"[FFFF33]" .. areaName,0,0,18,"center",false,true,"SpectralSC-SemiBold")
	
	--?? What is the state of the zone, Friendly or Chaotic
	dynWindow:AddLabel(100,18,"[00FF00]Friendly[-]",0,0,16,"center",false,true,"SpectralSC-SemiBold")

	-- not the best place to put the god button but it works
	if(IsImmortal(playerObj)) then
		dynWindow:AddButton(162,-107,"","",22,21,"","ToggleGodWindow",false,"God")
	end

	playerObj:OpenDynamicWindow(dynWindow)
end

-- REMOVED MAGICAL GUIDE
function UpdateHotbar(mobileObj)		
	local abilitySlotStartIndex = 29	

	local hasPrimary = GetWeaponAbility(mobileObj, true) ~= nil
	local hasSecondary = GetWeaponAbility(mobileObj, false) ~= nil
	local isNewPlayer =  mobileObj:GetObjVar("InitiateMinutes") ~= nil

	local abilityCount = 0
	if(hasPrimary) then abilityCount = abilityCount + 1 end
	if(hasSecondary) then abilityCount = abilityCount + 1 end
	if(isNewPlayer) then abilityCount = abilityCount + 1 end

	if(abilityCount == 0) then
		mobileObj:CloseDynamicWindow("actionbar")
	else
		local actionWindow = DynamicWindow("actionbar","",0,0,-90,-68,"Transparent","Bottom")
		local curX = 0
		if(abilityCount == 1) then
			curX = 65
		elseif(abilityCount == 2) then
			curX = 35
		end

		if(hasPrimary) then
			actionWindow:AddHotbarAction(curX,0,abilitySlotStartIndex,0,0,"SquareFixed",false)
			curX = curX + 60
		end

		if(hasSecondary) then
			actionWindow:AddHotbarAction(curX,0,abilitySlotStartIndex+1,0,0,"SquareFixed",false)
			curX = curX + 60
		end
		if(IsGod(mobileObj)) then
			UpdateWorldBuildingToolsWindow(mobileObj)
		end
		mobileObj:OpenDynamicWindow(actionWindow)
	end
end

function UpdateWorldBuildingToolsWindow(mobileObj)
	local toolWindow = DynamicWindow("gmtoolbar","",0,0,-90,-240,"Transparent","Right")
	toolWindow:AddLabel(18,-30,"[FF8822]World Building",0,50,14,"center",false,true,"SpectralSC-SemiBold")
	
	-- Right Bar
	profileSpawnerData = 
	{
		ID=	"createprofilespawner",
		ActionType="CustomCommand",
		DisplayName="Create Profile Spawner",
		Tooltip="Creates a profile spawner at your location.",
		Icon="Night",
		ServerCommand="CreateProfileSpawner",
		Enabled=true,		
	}
	toolWindow:AddLabel(18,-16,"[FFFF33]Spawning",0,50,12,"center",false,true,"SpectralSC-SemiBold")
	toolWindow:AddUserAction(0,0,profileSpawnerData,36,36,"SquareFixedNoHotkey")
	
	createStructuresData = 
	{
		ID=	"createstructures",
		ActionType="CustomCommand",
		DisplayName="Create Structures",
		Tooltip="Creates structures like houses, tents and other objects in which players can enter or things can live.",
		Icon="stable",
		ServerCommand="ToggleShowCreateStructures",
		Enabled=true,		
	}
	toolWindow:AddLabel(18,44,"[FFFF33]Structures",0,50,12,"center",false,true,"SpectralSC-SemiBold")
	toolWindow:AddUserAction(0,60,createStructuresData,36,36,"SquareFixedNoHotkey")

	lightingObjectsData = 
	{
		ID=	"createlightingobjects",
		ActionType="CustomCommand",
		DisplayName="Create Lighting",
		Tooltip="Create lighting objects to illuminate your world.",
		Icon="Illuminate",
		ServerCommand="ToggleShowCreateLighting",
		Enabled=true,		
	}
	toolWindow:AddLabel(18,104,"[FFFF33]Lighting",0,50,12,"center",false,true,"SpectralSC-SemiBold")
	toolWindow:AddUserAction(0,120,lightingObjectsData,36,36,"SquareFixedNoHotkey")	
	
	equipmentObjectsData = 
	{
		ID=	"createequipmentobjects",
		ActionType="CustomCommand",
		DisplayName="Create General Equipment",
		Tooltip="Create anything a player can equip or use in this world.",
		Icon="Dual Wield",
		ServerCommand="ToggleShowCreateEquipment",
		Enabled=true,		
	}
	toolWindow:AddLabel(18,164,"[FFFF33]Equipment",0,50,12,"center",false,true,"SpectralSC-SemiBold")
	toolWindow:AddUserAction(0,180,equipmentObjectsData,36,36,"SquareFixedNoHotkey")	

	resourceObjectsData = 
	{
		ID=	"createresourceobjects",
		ActionType="CustomCommand",
		DisplayName="Create General Resources",
		Tooltip="Create any general resource such as iron, leather, cloth and all other things players need to craft. \n\n[CCCC44]Note: All stackable items appear in stacks of 100",
		Icon="miningpickmining",
		ServerCommand="ToggleShowCreateResources",
		Enabled=true,		
	}
	toolWindow:AddLabel(18,224,"[FFFF33]Resources",0,50,12,"center",false,true,"SpectralSC-SemiBold")
	toolWindow:AddUserAction(0,240,resourceObjectsData,36,36,"SquareFixedNoHotkey")

	furnitureObjectsData = 
	{
		ID=	"createfurnitureobjects",
		ActionType="CustomCommand",
		DisplayName="Create General Furniture",
		Tooltip="Create tables, chairs and other deocrative house based items.",
		Icon="pickpocket",
		ServerCommand="ToggleShowCreateFurniture",
		Enabled=true,		
	}
	toolWindow:AddLabel(18,286,"[FFFF33]Furniture",0,50,12,"center",false,true,"SpectralSC-SemiBold")
	toolWindow:AddUserAction(0,300,furnitureObjectsData,36,36,"SquareFixedNoHotkey")

	decorationObjectsData = 
	{
		ID=	"createdecorationobjects",
		ActionType="CustomCommand",
		DisplayName="Create Decoration Objects",
		Tooltip="Create flowers, rocks, spoons, paintings.",
		Icon="chargedblast",
		ServerCommand="ToggleShowCreateDecorations",
		Enabled=true,		
	}
	toolWindow:AddLabel(18,346,"[FFFF33]Decorations",0,50,12,"center",false,true,"SpectralSC-SemiBold")
	toolWindow:AddUserAction(0,360,decorationObjectsData,36,36,"SquareFixedNoHotkey")

	dungeonEditorData = 
	{
		ID=	"dungeoneditor",
		ActionType="CustomCommand",
		DisplayName="Dungeon Editor",
		Tooltip="Allows you to build a dungeon and populate it with decorations, spawning, loot and other dungeon related things.",
		Icon="grimaura",
		ServerCommand="ToggleShowDungeonEditor",
		Enabled=true,		
	}
	toolWindow:AddLabel(18,406,"[FFFF33]DungeonEditor",0,50,12,"center",false,true,"SpectralSC-SemiBold")
	toolWindow:AddUserAction(0,420,dungeonEditorData,36,36,"SquareFixedNoHotkey")

	-- Left Bar
	reloadGlobalsData = 
	{
		ID=	"doreloadglobals",
		ActionType="CustomCommand",
		DisplayName="Reload Globals",
		Tooltip="This will reload all your scripts and refresh as if you just logged back in.",
		Icon="transience",
		ServerCommand="DoReloadGlobals",
		Enabled=true,		
	}
	toolWindow:AddLabel(-62,-16,"[FF7777]Reset Globals",0,50,12,"center",false,true,"SpectralSC-SemiBold")
	toolWindow:AddUserAction(-80,0,reloadGlobalsData,36,36,"SquareFixedNoHotkey")

	reloadTemplatesData = 
	{
		ID=	"doreloadtemplates",
		ActionType="CustomCommand",
		DisplayName="Reload TEmplates",
		Tooltip="This will reload all the templates, loads fresh templates just added as well.",
		Icon="transference",
		ServerCommand="DoReloadTemplates",
		Enabled=true,		
	}
	toolWindow:AddLabel(-62,44,"[FF7777]Reset Templates",0,60,12,"center",false,true,"SpectralSC-SemiBold")
	toolWindow:AddUserAction(-80,60,reloadTemplatesData,36,36,"SquareFixedNoHotkey")

	mobileObj:OpenDynamicWindow(toolWindow)
end