  require 'default:globals.helpers.crafting'

--- generate the item properties from the item property profile
function GenerateItemProperties(objRef,material,skillLevel,crafter,skillName)
	 local enchants = {}
	 for profileKey,profileValue in pairs(ItemProperties.Profile[objRef:GetCreationTemplateId()]) do
	 	if(math.random() <= profileValue.Chance) then
	 		local rnd = math.random(1,#profileValue.Enchants)
	 		local modifierValue = math.random(profileValue.Enchants[rnd].Intensity.Min,profileValue.Enchants[rnd].Intensity.Max)
	 		if(profileValue.Enchants[rnd].Intensity.Min < 1 and profileValue.Enchants[rnd].Intensity.Max < 1) then
	 			modifierValue = (math.random(profileValue.Enchants[rnd].Intensity.Min*100,profileValue.Enchants[rnd].Intensity.Max*100))/100
	 		end
	 		table.insert(enchants,
 			{
 				essenceName = profileValue.Enchants[rnd].EssenceKey,
 				essenceModifier = modifierValue,
 				-- profile key is so the alteration gem and chaos gem and exalted gem know what they can still add
 				profileKey = profileKey
 			})
	 	end
	 	tableSize = 0
	 end
	 if(#enchants > 0) then
	 	objRef:SetObjVar("Enchants",enchants)
	 	objRef:SetObjVar("MagicLevel",#enchants)
	 end
end

--- OVERRIDE CITADELS
function ApplyCraftedMaterialProperties(objRef, material, skillLevel, crafter, skillName)
	if ( objRef == nil ) then
		LuaDebugCallStack("[ApplyCraftedMaterialProperties] Nil objRef provided.")
		return
	end

	if(material) then
		-- set the color from material
		objRef:SetHue(Materials[material])
		-- set an objvar of the type of material
		objRef:SetObjVar("Material", material)
	end
	
	-- do we have a profile to generate item properties with?
	if(ItemProperties.Profile[objRef:GetCreationTemplateId()]) then
		GenerateItemProperties(objRef,material,skillLevel,crafter,skillName)
	end

	if(objRef:HasObjVar("MaxDurability")) then
		local durability = objRef:GetObjVar("MaxDurability") or ServerSettings.Durability.DefaultMax
		local bonusDurability = 0
		if(ItemProperties.MaterialBonus[material]) then
			bonusDurability = bonusDurability + math.random(ItemProperties.MaterialBonus[material].Durability.Min,ItemProperties.MaterialBonus[material].Durability.Max)
		end
		objRef:SetObjVar("MaxDurability", durability + bonusDurability)	
	end

	local enchants = objRef:GetObjVar("Enchants")
	if(enchants) then
	 	if(#enchants <= 2) then
	 		objRef:SetName(ItemProperties.ItemNameColor.Magic..StripColorFromString(objRef:GetName()))
	 	elseif(#enchants > 2) then
	 		objRef:SetName(ItemProperties.ItemNameColor.RareMagic..StripColorFromString(objRef:GetName()))
	 	end		
	 	
	 	-- set the magic level for disenchanting
	 	objRef:SetObjVar("MagicLevel",#enchants)
	 end
end
