require 'default:globals.helpers.enchanting'

EnchantingHelper.GetEnchantTooltip = function( essenseType, modifier )
    if( essenseType == nil ) then return "" end
    local data = EssenceData[essenseType]
    local tooltip = {}
    if( data ) then
        if( data.TooltipRanges ) then
            local set = false
            for i=1, #data.TooltipRanges do 
                if( not set and data.TooltipRanges[i].Max >= modifier ) then
                    table.insert(tooltip, data.TooltipRanges[i].Tooltip )
                    set = true
                end
            end
            if( not set ) then
                table.insert(tooltip, data.TooltipRanges[#data.TooltipRanges].Tooltip )
            end
        else
            local color = "[CCCC44]"
            if(modifier < 0) then color = "[FF4545]" end
            table.insert(tooltip, color..data.EffectName.."[-]")
            table.insert(tooltip, " ")

            if( data.EffectMode == "percent" ) then
                table.insert(tooltip, "+")
                if(modifier < 1) then
                    modifier = modifier * 100
                    table.insert(tooltip, tostring(modifier))
                else
                    table.insert(tooltip, tostring(modifier))
                end
                table.insert(tooltip, "%")                
            elseif(data.EffectMode == "plus") then
                if(modifier > 0) then
                    table.insert(tooltip, "+")
                    table.insert(tooltip, tostring(modifier))
                elseif(modifier < 0) then
                    -- the minus sign is implied in the num variable
                    table.insert(tooltip, color..tostring(modifier).."[-]")                    
                else
                end
            end          
        end
    end
    
    return table.concat(tooltip)
end