require 'default:globals.helpers.mobile'

--- Dismount a mobile, does nothing if not mounted
-- @param mobileObj
-- @param mountObj(optional)
-- @return boolean true if dismounted, false otherwise.
function DismountMobile(mobileObj, mountObj)
	mountObj = mountObj or GetMount(mobileObj)
	if ( mobileObj and mountObj ) then
		
		-- prevent dismounting more than once in a single frame (couple frames for good measure)
		if ( mobileObj:HasTimer("Dismounting") ) then return end
		mobileObj:ScheduleTimerDelay(TimeSpan.FromMilliseconds(200), "Dismounting")
		mobileObj:StopMoving()
		local statue = nil
		local loc = mobileObj:GetLoc()
		if ( statue ~= nil ) then
			local loc = mobileObj:GetLoc()
			mountObj:SetWorldPosition(loc)
			if ( statue:IsValid() ) then
				local backpack = mobileObj:GetEquippedObject("Backpack")
				if ( backpack ) then
					statue:MoveToContainer(backpack, statue:GetLoc())
				else
					statue:SetWorldPosition(mobileObj:GetLoc())
				end

				-- this objvar is used by autofixes to fix the horse template
				if not(statue:GetObjVar("DestroyHorse")) then
					mountObj:MoveToContainer(statue,Loc())
				else
					mountObj:Destroy()
					statue:DelObjVar("DestroyHorse")
				end
			else
				if ( mobileObj:IsPlayer() ) then
					mobileObj:SystemMessage("Mount statue was destroyed.", "info")
				end
				mountObj:Destroy()
			end
			PlayEffectAtLoc("CloakEffect", loc, 0.5)
		elseif( mountObj:HasObjVar("Summoned") ) then
			mountObj:Destroy()
			
			PlayEffectAtLoc("CloakEffect", loc, 0.5)
		else
			-- mountObj:SetWorldPosition(mobileObj:GetLoc())
			-- mountObj:SetObjectOwner(mobileObj)
			-- mountObj:SendMessage("BreakInvisEffect", "Dismount")
			-- AddUseCase(mountObj,"Mount",true,"IsController")
			-- SendPetCommandTo( mountObj, "follow", mobileObj )
			mountObj:Destroy()
			PlayEffectAtLoc("CloakEffect", loc, 0.5)
		end
		mobileObj:SendMessage("RecalculateStats", {MoveSpeed=true})-- mark movespeed stat dirty
		RemoveUseCase(mobileObj,"Dismount")
		mobileObj:SendMessage("BreakInvisEffect", "Dismount")
		return true
	end
	return false
end
