MobileEffectLibrary.CustomMounting = 
{
	OnEnterState = function(self,root,target,args)
		if(IsMounted(self.ParentObj)) then
			DismountMobile(self.ParentObj)
			EndMobileEffect(root)
			return false
		end
		
		-- prevent mounting in certain regions (like dungeons)
		if ( self.ParentObj:IsInRegion("NoMount") ) then
			self.ParentObj:SystemMessage("Cannot mount here.", "info")
			EndMobileEffect(root)
			return false
		end


		self._Applied = true

        SetMobileMod(self.ParentObj, "Busy", "Mounting", true)
		RegisterEventHandler(EventType.Message, "BreakInvisEffect", function(what)
			EndMobileEffect(root)
		end)
		RegisterEventHandler(EventType.StartMoving, "", function() EndMobileEffect(root) end)
		self.ParentObj:SendMessage("EndCombatMessage")
		self.ParentObj:StopMoving()
		
		self.ParentObj:PlayAnimation("cast")
		self.StartProgressBar(self,root)
		
		return true
	end,

	CreateFromTemplate = function(self,root)
		local template = "horse_saddled"
		local preferedMount = self.ParentObj:GetObjVar("PreferedMount") or {Category="Misc",CategoryKey="SkeletonHorsePvP"}
		template = MountCollection[preferedMount.Category][preferedMount.CategoryKey].Template or "horse_saddled"
		if ( template  ) then
			CreateObj(template, self.ParentObj:GetLoc(), "mountSpawned")
		else
			self.ParentObj:SystemMessage("This statue appears to be broken, cannot create the creatue.", "info")
			EndMobileEffect(root)
		end
		RegisterEventHandler(EventType.CreatedObject,"mountSpawned",function (success,objRef)
			self.MountObj = objRef
			local preferedMount = self.ParentObj:GetObjVar("PreferedMount") or {Category="Misc",CategoryKey="SkeletonHorsePvP"}
			local preferedMountData = MountCollection[preferedMount.Category][preferedMount.CategoryKey]
			objRef:SetHue(preferedMountData.Hue)
			objRef:SetColor(preferedMountData.Color)
			objRef:SetScale(Loc(preferedMountData.Scale,preferedMountData.Scale,preferedMountData.Scale))
			MountMobile(self.ParentObj, objRef)
			EndMobileEffect(root)
		end)
	end,

	OnExitState = function(self,root)
		if ( self._Applied ) then
			SetMobileMod(self.ParentObj, "Busy", "Mounting", nil)
			UnregisterEventHandler("", EventType.StartMoving, "")
			UnregisterEventHandler("", EventType.Message, "BreakInvisEffect")
			if ( self.ParentObj:HasTimer("MountingClose") ) then
				self.ParentObj:FireTimer("MountingClose") -- close progress bar
			end
			self.ParentObj:PlayAnimation("idle")
		end
	end,

	AiPulse = function(self,root)
			self.CreateFromTemplate(self,root)
	end,

	GetPulseFrequency = function(self,root)
		return self.Duration
	end,

    StartProgressBar = function(self,root)
        ProgressBar.Show(
        {
            TargetUser = self.ParentObj,
            Label = self.Statue ~= nil and "Summon Mount" or "Mount",
            Duration = self.Duration,
            PresetLocation = "AboveHotbar",
            DialogId = "Mounting",
        })
    end,

	Duration = TimeSpan.FromSeconds(3),
}
