MobileEffectLibrary.Bandage = 
{

	OnEnterState = function(self,root,target,args)
		self.Target = target or self.ParentObj
		self.IsPlayer = IsPlayerCharacter(target)
		self.IsOtherTarget = (self.ParentObj ~= target)

		if ( HasMobileEffect(self.ParentObj, "NoBandage") ) then
			if ( self.ParentObj:IsPlayer() ) then
				self.ParentObj:NpcSpeechToUser("You cannot bandage yet.",self.ParentObj)
			end
			EndMobileEffect(root)
			return false
		end
		if not( ValidateRangeWithError(SkillData.AllSkills.HealingSkill.Options.BandageRange, self.ParentObj, self.Target, "Too far away.") ) then
			EndMobileEffect(root)
			return false
		end
		if( not self.ParentObj:HasLineOfSightToObj(self.Target) ) then
			if( self.ParentObj:IsPlayer() ) then
				self.ParentObj:SystemMessage("You cannot see that.", "info")
			end
			EndMobileEffect(root)
			return false
		end
		if ( HasMobileEffect(target, "MortalStruck") ) then
			if ( self.IsPlayer ) then
				if ( self.ParentObj == target ) then
					self.ParentObj:NpcSpeechToUser("Cannot bandage right now.", self.ParentObj)
				else
					self.ParentObj:NpcSpeechToUser("They cannot be bandaged right now.", self.ParentObj)
				end
			end
			EndMobileEffect(root)
			return false
		end
		if (not self.ParentObj:IsMoving()) then
			self.ParentObj:PlayAnimation("bandage")
			self.ParentObj:ScheduleTimerDelay(TimeSpan.FromSeconds(2),"ReturnToIdle", true, self.ParentObj:GetLoc())
		end
		self._MaxHealth = GetMaxHealth(self.Target)

		if ( GetCurHealth(self.Target) >= self._MaxHealth ) then
			if ( self.ParentObj:IsPlayer() ) then
				self.ParentObj:NpcSpeechToUser("That patient seems fine.",self.ParentObj)
			end
			EndMobileEffect(root)
			return false
		end

		-- CHECK FOR MOBILE MODS
		local bonusBandageHealing = 0 

		if(self.IsOtherTarget) then
			bonusBandageHealing = GetCachedMobileModByName("BandageOtherHealPlus",self.ParentObj)
		else
			bonusBandageHealing = GetCachedMobileModByName("BandageHealPlus",self.ParentObj)
		end

		-- END CHECK FOR MOBILE MODS

		self._HealAmount = math.random(1,30) + 70 + bonusBandageHealing
		self.Target:SendMessage("HealRequest", self._HealAmount , self.ParentObj)
		StartMobileEffect(self.ParentObj, "NoBandage")
		self.Target:PlayEffect("PotionHealEffect")
		EndMobileEffect(root)
	end,

	-- for resurrecting.
	GetPulseFrequency = function(self,root) 
		return TimeSpan.FromSeconds(4)
	end,

	OnExitState = function(self,root)

	end,

	AiPulse = function(self,root)
		EndMobileEffect(root)
	end,
	
	ParentObj = nil,
	_HealAmount = 0,
	_MaxHealth = 0,
	_WasDead = false,
}