MobileEffectLibrary.Charged = 
{
	Caster = nil,
	Duration = SpellData.SpellEffectDuration.BuffSpells,
	Target = nil,
	AttackSpeedCap = 0.25,
	AttackSpeedMin = 0.05,
	MovementSpeedCap = 0.25,
	AttackSpeedMin = 0.05,
	OnEnterState = function(self,root,target,args)
		self.Caster = target
		self.Target = self.ParentObj

		-- set minimums
		self.Duration = self.Duration + TimeSpan.FromMinutes(bonusEnhancementDuration)
		-- apply buff icons
		if ( self.Target:IsPlayer() ) then
			AddBuffIcon(self.Target, "Charged", "Charged", "Lightning Nova", "A feeling of great haste and power resides in you, charging you.")
			SetMobileMod(self.Target, "MoveSpeedPlus", "Charged", 0.25)
			SetMobileMod(self.Target, "AttackSpeedTimes", "Charged", 0.25)
		end
		self.PlayEffects(self,root,target,args)
	end,
	OnExitState = function(self,root)
		-- remove buff icons and mobile modes
		if ( self.Target:IsPlayer() ) then
			RemoveBuffIcon(self.Target, "Charged")
			SetMobileMod(self.Target, "MoveSpeedPlus", "Charged", nil)
			SetMobileMod(self.Target, "AttackSpeedTimes", "Charged", nil)
			self.Target:SystemMessage("[FFFF77]charged begins to leaves you... you begin to slow down...")
			self.Caster:SystemMessage("[FFFF77]your charged on " .. self.Target:GetName() .. " has dwindled...")
		end
	end,
	OnStack = function(self,root,target,args)
		-- refresh duration
		root.ParentObj:ScheduleTimerDelay(self.Duration, root.PulseId.."-"..root.CurStateName)
		self.PlayEffects(self,root,target,args)
	end,
	GetPulseFrequency = function(self,root)
		return self.Duration
	end,
	AiPulse = function(self,root)
		EndMobileEffect(root)
	end,
	PlayEffects = function(self,root,target,args)
		self.Target:PlayObjectSound("event:/magic/misc/magic_water_restoration",false)
		self.Target:PlayEffectWithArgs("YellowPortalEffect",3.5,"Bone=Ground")
	end,
}