---
MagicKnowledgeUIStyles =
{
    ElectromancySkill =
    {
        BackgroundColor = "224499",
        BookName = "[EEEE88]Electromancy[-]",
        BookNameBackground = "222233",
        BookNameBackgroundBorder = "111133",
        IconName = "Lightning Mastery",
        IconBorderColor = "111133",        
        SpellTextColor ="[FFFF99]",
        SpellCircleColor = "[DDDDFF]",
    },    
    PyromancySkill =
    {
        BackgroundColor = "CC6600",
        BookName = "[EEEE88]Pyromancy[-]",
        BookNameBackground = "783914",
        BookNameBackgroundBorder = "b0531e",
        IconName = "Fire Mastery",
        IconBorderColor = "b0531e",        
        SpellTextColor ="[FFFF99]",
        SpellCircleColor = "[DDDDFF]",
    },
    TheologySkill =
    {
        BackgroundColor = "888822",
        BookName = "[EEEE88]Theology[-]",
        BookNameBackground = "4a4a01",
        BookNameBackgroundBorder = "595904",
        IconName = "Holy Mastery",
        IconBorderColor = "595904",        
        SpellTextColor ="[FFFF99]",
        SpellCircleColor = "[DDDDFF]",
    },
    BiomancySkill =
    {
        BackgroundColor = "449922",
        BookName = "[EEEE88]Biomancy[-]",
        BookNameBackground = "224422",
        BookNameBackgroundBorder = "335533",
        IconName = "Poison Skull",
        IconBorderColor = "335533",        
        SpellTextColor ="[FFFF99]",
        SpellCircleColor = "[DDDDFF]",
    },
    ConjurationSkill =
    {
        BackgroundColor = "3388CC",
        BookName = "[EEEE88]Conjuration[-]",
        BookNameBackground = "044a3b",
        BookNameBackgroundBorder = "0a614e",
        IconName = "Illuminate",
        IconBorderColor = "0a614e",        
        SpellTextColor ="[FFFF99]",
        SpellCircleColor = "[DDDDFF]",
    },              
}
---
MobileEffectLibrary.MagicKnowledge = 
{
    -- public variables for this mobile effect to reference
    WindowID = nil,
    StyleKey = nil,

    OnEnterState = function(self,root,target,args)
        self.WindowID = args.UIHandle or "ElectromancySkill"
        self.StyleKey = args.SchoolType or "ElectromancySkill"
        self.OpenWindow(self,root,target,args)
        -- Register window reponse listener
        RegisterEventHandler(EventType.DynamicWindowResponse, self.WindowID, function ( user, buttonId, fieldData ) self.WindowResponse( user, buttonId, fieldData, self, root, target, args ) end)
        RegisterEventHandler(EventType.ClientObjectCommand, "dropAction", function (user,sourceId,actionType,actionId,slot) self.HandleDropAction(user,sourceId,actionType,actionId,slot,self,root,target,args) end)
    end,

    OnExitState = function(self,root)
        UnregisterEventHandler("",EventType.DynamicWindowResponse, self.WindowID)
        self.ParentObj:CloseDynamicWindow(self.WindowID)
    end,

    OpenWindow = function(self,root,target,args)
        local uiKeyData = MagicKnowledgeUIStyles[self.StyleKey]
        local dynamicWindow = DynamicWindow(self.WindowID, ServerSettings.ChallengeSystem.Title,789,455,0,0,"TransparentDraggable")
        dynamicWindow:AddImage(312,-124,"HueSwatch",168,168,"Simple",uiKeyData.IconBorderColor)
        dynamicWindow:AddImage(316,-120,uiKeyData.IconName,160,160,"Sliced")
        dynamicWindow:AddImage(0,0,"Spellbook",789,455,"Simple",uiKeyData.BackgroundColor)

        dynamicWindow:AddImage(264,0,"HueSwatch",268,48,"Simple",uiKeyData.BookNameBackgroundBorder)
        dynamicWindow:AddImage(266,2,"HueSwatch",264,44,"Simple",uiKeyData.BookNameBackground)
        dynamicWindow:AddLabel(400,8,uiKeyData.SpellTextColor ..uiKeyData.BookName.."[-]",800,36,36,"center")  

        dynamicWindow:AddButton(727,22,"Close","",0,0,"","",false,"CloseSquare", buttonState)
        local y = 20
        local magicKnowledge = self.ParentObj:GetObjVar("MagicKnowledge")
        for k,v in pairs(magicKnowledge[args.SchoolType]) do
            y = y + 50
            local actionData = self.GetSpellUserAction(v)
            dynamicWindow:AddUserAction(120,y,actionData,48,48)    
            dynamicWindow:AddLabel(180,y+10,MagicKnowledgeUIStyles[self.StyleKey].SpellTextColor ..v.."[-]",200,24,24,"left")        
            dynamicWindow:AddLabel(180,y+30,MagicKnowledgeUIStyles[self.StyleKey].SpellCircleColor .. "Circle: "..SpellData.AllSpells[v].Circle.."[-]",200,16,16,"left")        
        end
        self.ParentObj:OpenDynamicWindow(dynamicWindow, self.ParentObj)
    end,

    GetSpellUserAction = function(spell)
        local spellData = SpellData.AllSpells[spell]
        local icon = spellData.Icon or spell:lower()
        if(spellData.Icon == nil and spellData.IconText ~= nil) then
            icon = "LighterSlotIcon"
        end
        local displayName = spellData.SpellDisplayName or spell
        local tooltip = spellData.SpellTooltipString
        local requirements = {}
        local manaCost = spellData.manaCost
        if(manaCost>0) then
            table.insert(requirements,{"Mana",manaCost})
        end
        local actionData = {
            ID = spell,
            ActionType = "Spell",
            DisplayName = displayName,
            Tooltip = tooltip,
            Icon = icon,
            IconText = spellData.IconText,
            Enabled = true,
            ServerCommand = "sp "..spell,
            Requirements = requirements
        }

        return actionData
    end,

    WindowResponse = function( user, buttonId, fieldData, self, root, target, args )
        EndMobileEffect(root)
    end,

    HandleDropAction = function (user,sourceId,actionType,actionId,slot,self,root,target,args)
         if((sourceId == self.WindowID) and slot ~= nil) then
            local hotbarAction = self.GetSpellUserAction(actionId)
            hotbarAction.Slot = tonumber(slot)
            RequestAddUserActionToSlot(user,hotbarAction)
        end
    end,
}
