require 'default:globals.static_data.prestige.skills'

PrestigeData.Skills.Abilities.Salvaging = 
{
	Action = 
	{
		DisplayName = "Salvaging",
		Icon = "Shield Breaker",	
		Enabled = true
	},

	NoResetSwing = true,
	NoCombat = true,
	Instant = true,
	NoDismount = true,

	Tooltip = "Target any equipment to break it down to its basic resources.",

	MobileEffect = "Salvaging",
	--MobileEffectArgs = {},
	Cooldown = TimeSpan.FromSeconds(5)
}

PrestigeData.Skills.Abilities.Disenchanting = 
{
	Action = 
	{
		DisplayName = "Disenchanting",
		Icon = "Dispel",	
		Enabled = true
	},

	NoResetSwing = true,
	NoCombat = true,
	Instant = true,
	NoDismount = true,

	Tooltip = "Target a magical object to break it down into its magical components.",

	MobileEffect = "Disenchanting",
	--MobileEffectArgs = {},
	Cooldown = TimeSpan.FromSeconds(5)
}

-- PrestigeData.Skills.Abilities.MagicKnowledge = 
-- {
-- 	Action = 
-- 	{
-- 		DisplayName = "Spell Knowledge",
-- 		Icon = "magicalguide",	
-- 		Enabled = true
-- 	},

-- 	NoResetSwing = true,
-- 	NoCombat = true,
-- 	Instant = true,
-- 	NoDismount = true,

-- 	Tooltip = "View your spell knowledge.",

-- 	MobileEffect = "MagicKnowledge",
-- 	Cooldown = TimeSpan.FromSeconds(1)
-- }

PrestigeData.Skills.Abilities.ElectromancyKnowledge = 
{
	Action = 
	{
		DisplayName = "Electromancy Knowledge",
		Icon = "Lightning Mastery",	
		Enabled = true
	},

	NoResetSwing = true,
	NoCombat = true,
	Instant = true,
	NoDismount = true,

	Tooltip = "Use this ability button to view your knowledge of Electromancy.",

	MobileEffect = "MagicKnowledge",
	MobileEffectArgs = {SchoolType="ElectromancySkill",UIHandle="ElectormancySkill"},
	Cooldown = TimeSpan.FromSeconds(1)
}

PrestigeData.Skills.Abilities.PyromancyKnowledge = 
{
	Action = 
	{
		DisplayName = "Pyromancy Knowledge",
		Icon = "Fire Mastery",	
		Enabled = true
	},

	NoResetSwing = true,
	NoCombat = true,
	Instant = true,
	NoDismount = true,

	Tooltip = "Use this ability button to view your knowledge of Pyromancy.",

	MobileEffect = "MagicKnowledge",
	MobileEffectArgs = {SchoolType="PyromancySkill",UIHandle="PyromancySkill"},
	Cooldown = TimeSpan.FromSeconds(1)
}

PrestigeData.Skills.Abilities.TheologyKnowledge = 
{
	Action = 
	{
		DisplayName = "Theology Knowledge",
		Icon = "Holy Mastery",	
		Enabled = true
	},

	NoResetSwing = true,
	NoCombat = true,
	Instant = true,
	NoDismount = true,

	Tooltip = "Use this ability button to view your knowledge of Theology.",

	MobileEffect = "MagicKnowledge",
	MobileEffectArgs = {SchoolType="TheologySkill",UIHandle="TheologySkill"},
	Cooldown = TimeSpan.FromSeconds(1)
}

PrestigeData.Skills.Abilities.BiomancyKnowledge = 
{
	Action = 
	{
		DisplayName = "Biomancy Knowledge",
		Icon = "Poison Skull",	
		Enabled = true
	},

	NoResetSwing = true,
	NoCombat = true,
	Instant = true,
	NoDismount = true,

	Tooltip = "Use this ability button to view your knowledge of Biomancy.",

	MobileEffect = "MagicKnowledge",
	MobileEffectArgs = {SchoolType="BiomancySkill",UIHandle="BiomancySkill"},
	Cooldown = TimeSpan.FromSeconds(1)
}

PrestigeData.Skills.Abilities.ConjurationKnowledge = 
{
	Action = 
	{
		DisplayName = "Conjuration Knowledge",
		Icon = "Illuminate",	
		Enabled = true
	},

	NoResetSwing = true,
	NoCombat = true,
	Instant = true,
	NoDismount = true,

	Tooltip = "Use this ability button to view your knowledge of Conjuration.",

	MobileEffect = "MagicKnowledge",
	MobileEffectArgs = {SchoolType="ConjurationSkill",UIHandle="ConjurationSkill"},
	Cooldown = TimeSpan.FromSeconds(1)
}

PrestigeData.Skills.Abilities.MountUp = 
{
	Action = 
	{
		DisplayName = "Mount Up",
		Icon = "Summon Black Horse",	
		Enabled = true
	},

	NoResetSwing = true,
	NoCombat = true,
	Instant = true,
	NoDismount = true,

	Tooltip = "summons your prefered mount.",

	MobileEffect = "CustomMounting",
	Cooldown = TimeSpan.FromSeconds(1)
}