function ShowItemPropertyWindow(user,item)
	local enchantsTable = item:GetObjVar("Enchants")
	if(enchantsTable) then 
		local dynamicWindow = DynamicWindow("ItemPropertyWindow","",250,430,275,320,"TransparentDraggable","Center")
		local scrollWindow = ScrollWindow(10,45,375,375,75)
		local scrollElement = nil    

	    -- create the main background window
	    dynamicWindow:AddImage(1,1,"HueSwatch",400,430,"Simple","252535")
	    dynamicWindow:AddImage(3,3,"HueSwatch",394,424,"Simple","151525")
	    
	    -- create the header background and text
	    dynamicWindow:AddImage(1,1,"HueSwatch",400,34,"Simple","353545")
	    dynamicWindow:AddImage(-2,-2,"CraftingItemsFrame",406,40,"Sliced","557575")
	    dynamicWindow:AddLabel(195,10,item:GetName(),230,20,20,"center")			
	
		-- draw the close button on the dynamic window
		DrawItemPropertyCloseButton(371,9,dynamicWindow)				
	
		-- create the scroll elements from the enchants this item has
		for index,value in pairs(enchantsTable) do
			-- grab a copy of the essences information so we can use
			-- the values needed to populate our textual information
			local essenceData = EssenceData[value.essenceName]
			if(essenceData) then
				scrollElement = ScrollElement()
				-- draw framing
				scrollElement:AddImage(1,1,"HueSwatch",360,75,"Simple","151525")
				scrollElement:AddImage(2,2,"HueSwatch",358,73,"Simple","353545")
				scrollElement:AddImage(2,26,"HueSwatch",358,2,"Simple","151525")
				scrollElement:AddImage(2,28,"HueSwatch",358,47,"Simple","252535")
				-- add text information
				scrollElement:AddLabel(180,5,"[B5B577]"..essenceData.Name,360,20,20,"center")
				scrollElement:AddLabel(4,30,"[CDCDCD]"..essenceData.EquipmentEditorTooltip,352,48,16,"left")
				-- attach the scroll elemental to the scroll window
				scrollWindow:Add(scrollElement) 		
			end
		end

	    --attach the scrollWindow object to the dynamic window
		dynamicWindow:AddScrollWindow(scrollWindow)

		-- open up the finalized dynamic window for the user
		-- NOTE: passing the item means nothing as we don't care about any responses
		-- though it sends the event DynamicWindowResponse with the "ItemPropertyWindow"
		-- handle.
		user:OpenDynamicWindow(dynamicWindow,item)
	else
		user:SystemMessage("this item has no magical properties")
	end
end

function DrawItemPropertyCloseButton(x,y,dynamicWindow)
	--border background color
	dynamicWindow:AddImage(x,y,"Blank",18,18,"Sliced","555555")
	--background color
	dynamicWindow:AddImage(x+2,y+2,"Blank",14,14,"Sliced","252525")
	--invisible button
	dynamicWindow:AddButton(x,y,"CloseButton","",18,18,"[FF7700]Close Button\n[959555]clicking this will close the item property window.","",true,"Invisible")
	--draw the "X" string
	dynamicWindow:AddLabel(x+5,y+3,"[959555]X",18,18,18,"left")
end