---------------------------------------------------------
-- COLOR DEFINITIONS TABLE
---------------------------------------------------------
-- color definitions used by the login_player
---------------------------------------------------------
ColorDefinitions =
{
	Black = "000000",
	Text = "AA8844",
	Text2 = "FFCC99",
	TextBackground = "FF7700",
	ButtonBorder = "251505",
	ButtonBackground = "352505",
	ButtonText = "AA8844",
	ButtonText2 = "999999",
	DividerColor = "FF8844",
	IntroductionIcon = "FF7700",
	EnterWorldButtonTooltip = "CCCC55",
}

-- ---------------------------------------------------------
-- -- RACES TABLE
-- ---------------------------------------------------------
-- -- race definitions used by login player
-- ---------------------------------------------------------
-- RaceDefinitions = {}
-- -- TODO: MOVE TO GLOBALS FOR ACCESSING IN OTHER SCRIPTS TO KEEP THINGS UNIFORM
-- RaceDefinitions.Human =
-- {
-- 	BodyParts = 
-- 	{
-- 		-- races all have the same head model
-- 		HeadModels = { Male = "head_male02", Female = "head_female02", },
-- 		-- starting hair models
-- 		HairModels = { Male = { "hair_male", }, Female = { "hair_female", }, },
-- 		HairHue = { Male = { 768, 788, 793, }, Female = { 768, 788, 793, }, },
-- 		SkinHue = { Male = { 807, 808, 809, }, Female = { 807, 808, 809, }, }
-- 	},
-- 	Stats = 
-- 	{ 
-- 		Agi = 20, 
-- 		Int = 30, 
-- 		Str = 30, 
-- 		Will = 20, 
-- 		Wis = 10, 
-- 	},
-- }

---------------------------------------------------------
-- STARTING BUILDS TABLE
---------------------------------------------------------
-- starting character templates used by login player
---------------------------------------------------------
StartingCharacterBuilds = {}

StartingCharacterBuilds.CasterBiomancer =
{
	BuildType = "Spellcaster",
	DisplayName = "Biomancer",
	Icon = 
	{
		Primary = "Skill_Manifestation",
		Secondary = "Skill_Blocking",
	},
	EnterWorldButtonTooltip = "["..ColorDefinitions.EnterWorldButtonTooltip.."]May the Gods protect you on your journey no matter who you decide to be\n",
	Introduction = "Starting Skills\nCasting: Biomancy 10 Skill\nCasting: Meditation 10 Skill\n",
	Skills =
	{		
		{ SkillName = "BiomancySkill", StartValue = 10, },
		{ SkillName = "ChannelingSkill", StartValue = 10, },
	},
	StartingStats =
	{
		Str = 10,
		Agi = 10,
		Int = 15,
		Will = 10,
		Wis = 10,
	},	
	Template = "starting_template_biomancer",
}

StartingCharacterBuilds.CasterElectromancer =
{
	BuildType = "Spellcaster",
	DisplayName = "Electromancer",
	Icon = 
	{
		Primary = "Skill_Manifestation",
		Secondary = "Skill_Blocking",
	},
	EnterWorldButtonTooltip = "["..ColorDefinitions.EnterWorldButtonTooltip.."]May the Gods protect you on your journey no matter who you decide to be\n",
	Introduction = "Starting Skills\nCasting: Electromancy 10 Skill\nCasting: Meditation 10 Skill\n",
	Skills =
	{		
		{ SkillName = "ElectromancySkill", StartValue = 10, },
		{ SkillName = "ChannelingSkill", StartValue = 10, },
	},
	StartingStats =
	{
		Str = 10,
		Agi = 10,
		Int = 15,
		Will = 10,
		Wis = 10,
	},	
	Template = "starting_template_electromancer",
}

StartingCharacterBuilds.CasterConjurer =
{
	BuildType = "Spellcaster",
	DisplayName = "Conjurer",
	Icon = 
	{
		Primary = "Skill_Manifestation",
		Secondary = "Skill_Blocking",
	},
	EnterWorldButtonTooltip = "["..ColorDefinitions.EnterWorldButtonTooltip.."]May the Gods protect you on your journey no matter who you decide to be\n",
	Introduction = "Starting Skills\nCasting: Conjuration 10 Skill\nCasting: Meditation 10 Skill\n",
	Skills =
	{		
		{ SkillName = "ConjurationSkill", StartValue = 10, },
		{ SkillName = "ChannelingSkill", StartValue = 10, },
	},
	StartingStats =
	{
		Str = 10,
		Agi = 10,
		Int = 15,
		Will = 10,
		Wis = 10,
	},	
	Template = "starting_template_conjurer",
}

StartingCharacterBuilds.CasterPyromancer =
{
	BuildType = "Spellcaster",
	DisplayName = "Pyromancer",
	Icon = 
	{
		Primary = "Skill_Manifestation",
		Secondary = "Skill_Blocking",
	},
	EnterWorldButtonTooltip = "["..ColorDefinitions.EnterWorldButtonTooltip.."]May the Gods protect you on your journey no matter who you decide to be\n",
	Introduction = "Starting Skills\nCasting: Pyromancy 10 Skill\nCasting: Meditation 10 Skill\n",
	Skills =
	{		
		{ SkillName = "TheologySkill", StartValue = 10, },
		{ SkillName = "ChannelingSkill", StartValue = 10, },
	},
	StartingStats =
	{
		Str = 10,
		Agi = 10,
		Int = 15,
		Will = 10,
		Wis = 10,
	},	
	Template = "starting_template_pyromancer",
}

StartingCharacterBuilds.CasterTheology =
{
	BuildType = "Spellcaster",
	DisplayName = "Theologist",
	Icon = 
	{
		Primary = "Skill_Manifestation",
		Secondary = "Skill_Blocking",
	},
	EnterWorldButtonTooltip = "["..ColorDefinitions.EnterWorldButtonTooltip.."]May the Gods protect you on your journey no matter who you decide to be\n",
	Introduction = "Starting Skills\nCasting: Theology 10 Skill\nCasting: Meditation 10 Skill\n",
	Skills =
	{		
		{ SkillName = "TheologySkill", StartValue = 10, },
		{ SkillName = "ChannelingSkill", StartValue = 10, },
	},
	StartingStats =
	{
		Str = 10,
		Agi = 10,
		Int = 15,
		Will = 10,
		Wis = 10,
	},	
	Template = "starting_template_theologist",
}


StartingCharacterBuilds.Swordsman =
{
	BuildType = "Melee Combat",
	DisplayName = "Swordsman",
	Icon = 
	{
		Primary = "Skill_Manifestation",
		Secondary = "Skill_Blocking",
	},
	EnterWorldButtonTooltip = "["..ColorDefinitions.EnterWorldButtonTooltip.."]May the Gods protect you on your journey no matter who you decide to be\n",
	Introduction = "Starting Skills\nCombat: Slashing 10 Skill\nCombat: Tactics 10 Skill\n",
	Skills =
	{		
		{ SkillName = "SlashingSkill", StartValue = 10, },
		{ SkillName = "TacticsSkill", StartValue = 10, },
	},
	StartingStats =
	{
		Str = 15,
		Agi = 10,
		Int = 10,
		Will = 10,
		Wis = 10,
	},	
	Template = "starting_template_swordsman",
}

StartingCharacterBuilds.Fencer =
{
	BuildType = "Melee Combat",
	DisplayName = "Fencer",
	Icon = 
	{
		Primary = "Skill_Manifestation",
		Secondary = "Skill_Blocking",
	},
	EnterWorldButtonTooltip = "["..ColorDefinitions.EnterWorldButtonTooltip.."]May the Gods protect you on your journey no matter who you decide to be\n",
	Introduction = "Starting Skills\nCombat: Piercing 10 Skill\nCombat: Tactics 10 Skill\n",
	Skills =
	{		
		{ SkillName = "PiercingSkill", StartValue = 10, },
		{ SkillName = "TacticsSkill", StartValue = 10, },
	},
	StartingStats =
	{
		Str = 10,
		Agi = 15,
		Int = 10,
		Will = 10,
		Wis = 10,
	},	
	Template = "starting_template_fencer",
}

StartingCharacterBuilds.Mauler =
{
	BuildType = "Melee Combat",
	DisplayName = "Mauler",
	Icon = 
	{
		Primary = "Skill_Manifestation",
		Secondary = "Skill_Blocking",
	},
	EnterWorldButtonTooltip = "["..ColorDefinitions.EnterWorldButtonTooltip.."]May the Gods protect you on your journey no matter who you decide to be\n",
	Introduction = "Starting Skills\nCombat: Bashing 10 Skill\nCombat: Tactics 10 Skill\n",
	Skills =
	{		
		{ SkillName = "BashingSkill", StartValue = 10, },
		{ SkillName = "TacticsSkill", StartValue = 10, },
	},
	StartingStats =
	{
		Str = 15,
		Agi = 10,
		Int = 10,
		Will = 10,
		Wis = 10,
	},	
	Template = "starting_template_mauler",
}

StartingCharacterBuilds.Lancer =
{
	BuildType = "Melee Combat",
	DisplayName = "Lancer",
	Icon = 
	{
		Primary = "Skill_Manifestation",
		Secondary = "Skill_Blocking",
	},
	EnterWorldButtonTooltip = "["..ColorDefinitions.EnterWorldButtonTooltip.."]May the Gods protect you on your journey no matter who you decide to be\n",
	Introduction = "Starting Skills\nCombat: Lancing 10 Skill\nCombat: Tactics 10 Skill\n",
	Skills =
	{		
		{ SkillName = "LancingSkill", StartValue = 10, },
		{ SkillName = "TacticsSkill", StartValue = 10, },
	},
	StartingStats =
	{
		Str = 10,
		Agi = 15,
		Int = 10,
		Will = 10,
		Wis = 10,
	},	
	Template = "starting_template_lancer",
}

StartingCharacterBuilds.Archer =
{
	BuildType = "Ranged Combat",
	DisplayName = "Archer",
	Icon = 
	{
		Primary = "Skill_Manifestation",
		Secondary = "Skill_Blocking",
	},
	EnterWorldButtonTooltip = "["..ColorDefinitions.EnterWorldButtonTooltip.."]May the Gods protect you on your journey no matter who you decide to be\n",
	Introduction = "Starting Skills\nCombat: Archery 10 Skill\nCombat: Tactics 10 Skill\n",
	Skills =
	{		
		{ SkillName = "ArcherySkill", StartValue = 10, },
		{ SkillName = "TacticsSkill", StartValue = 10, },
	},
	StartingStats =
	{
		Str = 10,
		Agi = 15,
		Int = 10,
		Will = 10,
		Wis = 10,
	},	
	Template = "starting_template_archer",
}
