-----------------------------------------------------------------------------
-- CORE
-----------------------------------------------------------------------------
StoreTypes = {}

-- these control the colors on the store tooltip 
ToolTipHeaderColor = "[FF7700]"
ToolTipTextColor = "[FFFFAA]"

-----------------------------------------------------------------------------
-- STORE TABLE KEYS
-----------------------------------------------------------------------------
-- StoreType
-- MerchantTitle - this is the title the merchant will have
-- CurrencyType - the object the vender accepts as payment (coins,lemon_grass,anything)
-- CurrencyName - display name for the currency needed
-- Stock - a table containing stock keys for items to sell and buy
-- 
-- Stock
-- DisplayName - the display name on the ui menu
-- Template - the template file for this object
-- SellPrice - the price to sell to the player
-- BuyPrice - the price to buy from the player
-- CanSell - can the merchant sell this item?
-- CanBuy - can the merchant buy this item
-- Tooltip - the tooltip for the mouseover on the item selection in the ui

-- below is an example of a simple storetype table setup

-- StoreTypes.DaggerStore = 
-- {
-- 	MerchantTitle = "-Dagger Merchant-",
-- 	CurrencyType = "coins",
-- 	CurrencyName = "Coins",
-- 	Stock =
-- 	{
-- 		Dagger =
-- 		{
-- 			DisplayName="Dagger",
-- 			Template="weapon_dagger",
-- 			SellPrice=36,
-- 			BuyPrice=12,
-- 			MaxStock=20,
-- 			CanSell = true,
-- 			CanBuy = true,
-- 			Tooltip = ToolTipHeaderColor.."-Dagger-\n"..ToolTipTextColor.." - description required",
-- 		},		
-- 	}
-- }

-- add custom merchant store tables here
require 'merchants.stores.weaponsmith'
require 'merchants.stores.armorsmith'
require 'merchants.stores.alchemist'
require 'merchants.stores.provisioner'
require 'merchants.stores.banker'
require 'merchants.stores.carpenter'
require 'merchants.stores.tailor'
require 'merchants.stores.scribe'
require 'merchants.stores.leatherworker'
require 'merchants.stores.recipes_weapons'
require 'merchants.stores.recipes_armor'
require 'merchants.stores.recipes_tailor'
require 'merchants.stores.recipes_leather'
require 'merchants.stores.recipes_bows'
require 'merchants.stores.reagent'
require 'merchants.stores.scrolls'
require 'merchants.stores.generalmounts'
