CreationMenu = {}

CreationMenu.Structures =
{
	{
		Name = "Structures",
		DoDecorationTool = true,
		Categories =
		{
			{
				Name = "Tents & Huts",
				Templates =
				{
					{Name = "Bandit - Large",Template = "tent_bandit" },
					{Name = "Bandit - Small",Template = "tent_bandit_small" },
					{Name = "Barbarian",Template = "tent_barbarian" },
					{Name = "Barbarian 2",Template = "tent_barbarian_2" },
					{Name = "Black Vampire",Template = "tent_black_vampire" },
					{Name = "Blue - Large",Template = "tent_blue_large" },
					{Name = "Blue - Small",Template = "tent_dome_small" },
					{Name = "Orc - Large",Template = "tent_orc" },
					{Name = "Orc - Small",Template = "tent_orc_small" },
					{Name = "Wood - Small",Template = "tent_wood_small" },
				},				
			},
			{
				Name = "Homes - Wooden",
				Templates =
				{
					{Name = "Blacksmitht",Template = "wood_house_blacksmith_south" },
					{Name = "Birch",Template = "wood_house_birch_east" },
					{Name = "Cottage",Template = "wood_house_cottage_east" },
					{Name = "Mahogany",Template = "wood_house_mahogany_east" },
					{Name = "Oak",Template = "wood_house_oak_east" },
					{Name = "Tavern",Template = "wood_house_tavern_east" },
					{Name = "Shack",Template = "wood_house_south" },
				},
			},			
			{
				Name = "Homes - Stone",
				Templates =
				{
					{Name = "Blacksmith",Template = "stone_house_blackksmith_east" },
					{Name = "Cottage",Template = "stone_house_cottage_east" },
					{Name = "Double",Template = "stone_house_double_east" },
					{Name = "Estate",Template = "stone_house_estate_east" },
					{Name = "Lodge",Template = "stone_house_lodge_east" },
					{Name = "Tuscan",Template = "stone_house_tuscan_east" },
					{Name = "Villa",Template = "stone_house_villa_east" },
				},
			},	
			{
				Name = "Homes - Terracotta",
				Templates =
				{
					{Name = "Cottage",Template = "terracotta_house_cottage_east" },
					{Name = "Double",Template = "terracotta_house_double_east" },
					{Name = "Estate",Template = "terracotta_house_estate_east" },
					{Name = "Lodge",Template = "terracotta_house_lodge_east" },
					{Name = "Manor",Template = "terracotta_house_manor_east" },
					{Name = "Tuscan",Template = "terracotta_house_tuscan_east" },
					{Name = "Villa",Template = "terracotta_house_villa_east" },
				},
			},
			{
				Name = "Homes - Tudor",
				Templates =
				{
					{Name = "Blacksmith",Template = "tudor_house_blackksmith_east" },
					{Name = "Birch",Template = "tudor_house_birch_east" },
					{Name = "Birch - Wood",Template = "tudor_house_birch_wood_east" },
					{Name = "Estate",Template = "tudor_house_estate_east" },
					{Name = "Mahogany",Template = "tudor_house_mahogany_east" },
					{Name = "Manor",Template = "tudor_house_manor_east" },
					{Name = "Oak",Template = "tudor_house_oak_east" },
					{Name = "Tavern",Template = "tudor_house_tavern_east" },
				},
			},										
			{
				Name = "Guard Towers",
				Templates =
				{
					{Name = "Guard Tower - 1",Template = "guard_tower" },
					{Name = "Guard Tower - 2",Template = "guard_tower2" },
					{Name = "Guard Tower - 3",Template = "guard_tower3" },
					{Name = "Guard Tower - 4",Template = "guard_tower4" },
					{Name = "Guard Tower - 5",Template = "guard_tower5" },
				},
			},
			{
				Name = "Doors",
				Templates =
				{
					{Name = "House - Tudor",Template = "house_door_tudor" },
					{Name = "Dungeon - Steel",Template = "catacombs_steel_door" },
					{Name = "Dungeon - Cell",Template = "cell_door" },
					{Name = "Dungeon - Desert",Template = "dungeon_desert_door" },
					{Name = "Dungeon - Forest",Template = "dungeon_forest_door" },
					{Name = "Dungeon - Stone",Template = "dungeon_stone_door" },
					{Name = "Gate - Large",Template = "eldeir_door" },
					{Name = "Gate - Fence",Template = "fence_door" },
					{Name = "House - Tudor Dark",Template = "house_door_tudor_dark" },
					{Name = "House - Tudor Fine",Template = "house_door_tudor_fine" },
					{Name = "House - Tundra",Template = "house_door_tundra" },
					{Name = "House - Wood",Template = "house_door_wood" },
					{Name = "Mausoleum",Template = "mausoleum_door" },
					{Name = "Mausoleum - Floor",Template = "mausoleum_door_floor" },
				},
			},														
		},
	}
}

CreationMenu.Lighting =
{
	{
		Name = "Lighting",
		DoDecorationTool = true,
		Categories =
		{
			{
				Name = "Fires",
				Templates =
				{
					{Name = "Campfire - Simple",Template = "campfire_simple" },
					{Name = "Campfire",Template = "campfire" },
					{Name = "Campfire - Cultist 1",Template = "campfire_cultist" },
					{Name = "Campfire - Cultist 2",Template = "campfire_cultist2" },
					{Name = "Campfire - Large",Template = "campfire_large" },
					{Name = "Campfire - Giant",Template = "giant_bonfire" },
				},				
			},
			{
				Name = "Torches",
				Templates =
				{
					{Name = "Torch - Wooden Standing",Template = "furniture_standing_torch_wood" },
					{Name = "Torch - Crystal Standing",Template = "furniture_standing_torch_crystal" },				
					{Name = "Torch - Road",Template = "road_torch" },				
					{Name = "Torch - Road Mossy",Template = "road_torch_moss" },				
					{Name = "Torch - Road Sand",Template = "road_torch_sand" },				
					{Name = "Torch - Wall Simple",Template = "torch_catacombs_dirt" },				
					{Name = "Torch - Wall Gothic",Template = "torch_gothic" },				
				},
			},
			{
				Name = "Lanterns",
				Templates =
				{
					{Name = "Floor - Regular",Template = "furniture_lantern_floor" },
					{Name = "Floor - Crystal",Template = "furniture_lantern_floor_crystal" },
					{Name = "Floor - Crystal Tall",Template = "furniture_lantern_floor_crystal_tall" },
					{Name = "Hanging - Normal",Template = "furniture_lantern_hanging" },
					{Name = "Hanging - Crystal",Template = "furniture_lantern_hanging_crystal" },
					{Name = "Hanging - Red",Template = "furniture_lantern_hanging_red" },
					{Name = "Hanging - Red Round",Template = "furniture_lantern_hanging_red_round" },
					{Name = "Hanging - Steel",Template = "furniture_lantern_hanging_steel" },
					{Name = "Hanging - Mine",Template = "furniture_lantern_mine_hanging" },
					{Name = "Post - Regular",Template = "furniture_lantern_post" },
					{Name = "Sconce - Crystal",Template = "furniture_lantern_sconce_crystal" },
					{Name = "Sconce - Red",Template = "furniture_lantern_sconce_red" },
					{Name = "Sconce - Red Round",Template = "furniture_lantern_sconce_red_round" },
					{Name = "Sconce - Steel",Template = "furniture_lantern_sconce_steel" },
					{Name = "Wall - Regular",Template = "furniture_lantern_wall" },
					{Name = "Wall - Crystal",Template = "furniture_lantern_wall_crystal" },
					{Name = "Wall - Red",Template = "furniture_lantern_wall_red" },
					{Name = "Wall - Red Round",Template = "furniture_lantern_wall_red_round" },
					{Name = "Wall - Steel",Template = "furniture_lantern_wall_steel" },
					{Name = "Lantern Line",Template = "lantern_line" },
					{Name = "Lantern Pillar",Template = "lantern_pillar" },
					{Name = "Lantern - Street",Template = "lantern_street" },
				},				
			},			
		},
	}
}

CreationMenu.Equipment =
{
	{
		Name = "Equipment",
		DoDecorationTool = true,
		Categories =
		{
			{
				Name = "Weapons",
				Templates =
				{
					{Name = "Long Bow",Template = "weapon_longbow" },
					{Name = "Short Bow",Template = "weapon_shortbow" },
					{Name = "War Bow",Template = "weapon_warbow" },
					{Name = "Hammer",Template = "weapon_hammer" },
					{Name = "Mace",Template = "weapon_mace" },
					{Name = "Maul",Template = "weapon_maul" },
					{Name = "War Mace",Template = "weapon_war_mace" },
					{Name = "War Hammer",Template = "weapon_warhammer" },
					{Name = "Halberd",Template = "weapon_halberd" },
					{Name = "Spear",Template = "weapon_spear" },
					{Name = "Pitchfork",Template = "weapon_warfork" },
					{Name = "Bone Dagger",Template = "weapon_bone_dagger" },
					{Name = "Dagger",Template = "weapon_dagger" },
					{Name = "Kryss",Template = "weapon_kryss" },
					{Name = "Poniard",Template = "weapon_poniard" },
					{Name = "Braodswoard",Template = "weapon_broadsword" },
					{Name = "Great Axe",Template = "weapon_greataxe" },
					{Name = "Katana",Template = "weapon_katana" },
					{Name = "Large Axe",Template = "weapon_largeaxe" },
					{Name = "Longsword",Template = "weapon_longsword" },
					{Name = "Saber",Template = "weapon_saber" },
				},				
			},
			{
				Name = "Armor",
				Templates =
				{
					{Name = "Chain Helm",Template = "armor_chain_helm" },
					{Name = "Chain Leggings",Template = "armor_chain_leggings" },
					{Name = "Chain Tunic",Template = "armor_chain_tunic" },
					{Name = "Full Plate Helm",Template = "armor_fullplate_helm" },
					{Name = "Full Plate Leggings",Template = "armor_fullplate_leggings" },
					{Name = "Full Plate Tunic",Template = "armor_fullplate_tunic" },
					{Name = "Hardened Leather Helm",Template = "armor_hardened_helm" },
					{Name = "Hardened Leather Leggings",Template = "armor_hardened_leggings" },
					{Name = "Hardened Leather Tunic",Template = "armor_hardened_chest" },
					{Name = "Leather Helm",Template = "armor_leather_helm" },
					{Name = "Leather Leggings",Template = "armor_leather_leggings" },
					{Name = "Leather Tunic",Template = "armor_leather_chest" },
					{Name = "Linen Helm",Template = "armor_linen_helm" },
					{Name = "Linen Leggings",Template = "armor_linen_leggings" },
					{Name = "Linen Tunic",Template = "armor_linen_tunic" },
					{Name = "Padded Helm",Template = "armor_padded_helm" },
					{Name = "Padded Leggings",Template = "armor_padded_leggings" },
					{Name = "Padded Tunic",Template = "armor_padded_tunic" },
					{Name = "Wizards Hat",Template = "armor_wizards_hat" },
					{Name = "Wizards Robe",Template = "armor_wizards_robe" },
				},
			},			
			{
				Name = "Shields",
				Templates =
				{
					{Name = "Buckler",Template = "shield_buckler" },
				},
			},			
		},
	}
}

CreationMenu.Resources=
{
	{
		Name = "Resources",
		Categories =
		{
			{
				Name = "Metal",
				Templates =
				{
					{Name = "Ingot - Iron",Template = "resource_iron" },
					{Name = "Ingot - Copper",Template = "resource_copper" },
					{Name = "Ingot - Gold",Template = "resource_gold" },
					{Name = "Ingot - Cobalt",Template = "resource_cobalt" },
					{Name = "Ingot - Obsidian",Template = "resource_obsidian" },
				},				
			},
			{
				Name = "Leather",
				Templates =
				{
					{Name = "Leather",Template = "resource_leather" },
					{Name = "Leather - Beast",Template = "resource_beast_leather" },
					{Name = "Leather - Vile",Template = "resource_vile_leather" },
				},
			},			
			{
				Name = "Wood",
				Templates =
				{
					{Name = "Boards",Template = "resource_boards" },
					{Name = "Boards - Ash",Template = "resource_boards_ash" },
					{Name = "Boards - Blightwood",Template = "resource_blightwood_boards" },
				},
			},			
			{
				Name = "Reagents",
				Templates =
				{
					{Name = "Lemon Grass",Template = "ingredient_lemongrass" },
					{Name = "Moss",Template = "ingredient_moss" },
					{Name = "Ginseng",Template = "ingredient_ginsengroot" },
					{Name = "Mushrooms",Template = "ingredient_mushroom" },
					{Name = "Holy Water",Template = "holy_water" },
				},
			},
			{
				Name = "Cloth",
				Templates =
				{
					{Name = "Bolt of Cloth",Template = "resource_bolt_of_cloth" },
					{Name = "Bolt of Cloth - Quilted",Template = "resource_bolt_of_cloth_quilted" },
					{Name = "Bolt of Cloth - Silk",Template = "resource_silk_cloth" },
				},
			},
			{
				Name = "Gems",
				Templates =
				{
					{Name = "Gem of Chaos",Template = "gem_of_chaos" },
					{Name = "Gem of Regal",Template = "gem_of_regal" },
					{Name = "Gem of Alchemy",Template = "gem_of_alchemy" },
					{Name = "Gem of Exalted",Template = "gem_of_exalted" },
					{Name = "Gem of Alteration",Template = "gem_of_alteration" },
					{Name = "Gem of Transmogrification",Template = "gem_of_transmogrification" },
				},
			},									
		},
	}
}

CreationMenu.Furniture=
{
	{
		Name = "Furniture",
		DoDecorationTool = true,
		Categories =
		{
			{
				Name = "Containers",
				Templates =
				{
					{Name = "Crate - Empty",Template = "crate_empty" },
					{Name = "Crate - Large Covered In Cloth",Template = "crate_mine_large_cloth" },
					{Name = "Crate - Large",Template = "crate_mine_large" },
					{Name = "Crate - Empty And Open",Template = "crate_open_empty" },
					{Name = "Crate - Dark Stained",Template = "crate_ship" },
					{Name = "Crate - Pile Covered In A Net",Template = "crate_ship_netted" },
					{Name = "Crate - Large Low Quality",Template = "market_stall_counter_crate_blank" },
					{Name = "Mailbox - Stone",Template = "mailbox_stone" },
					{Name = "Mailbox - Tudor",Template = "mailbox_tudor" },
					{Name = "Mailbox - Wooden",Template = "mailbox_wooden" },
				},				
			},
			{
				Name = "Tables",
				Templates =
				{
					{Name = "Stone Table - Blacksmith",Template = "furniture_table_blacksmith" },
					{Name = "End Table - Shanty",Template = "end_table_circle_shanty_blank" },
					{Name = "End Table - Square",Template = "endtable_square_blackcherry_blank" },
					{Name = "Stone Table - Large Circle",Template = "furniture_stone_table" },
					{Name = "Wooden - Red Cloth",Template = "furniture_table_cloth" },
					{Name = "Wooden - Trashy",Template = "furniture_table_cultist" },
					{Name = "Wooden - Dark With Red Cloth",Template = "furniture_table_feast" },
					{Name = "Wooden - Inn Dark Stained",Template = "furniture_table_inn" },
					{Name = "Wooden - Inn Light Stained",Template = "furniture_table_inn_dark" },
					{Name = "Wooden - Library",Template = "furniture_table_library" },
					{Name = "Wooden - Round",Template = "furniture_table_round" },
					{Name = "Wooden - Large",Template = "furniture_table_wooden_large" },
					{Name = "Wooden - Fancy",Template = "furniture_table_wooden" },
					{Name = "Wooden - Stone & Board",Template = "furniture_table_wooden_plank" },
				},
			},			
			{
				Name = "Chairs",
				Templates =
				{
					{Name = "Wooden - Cushion",Template = "furniture_chair" },
					{Name = "Wooden - Fancy",Template = "furniture_chair_fancy" },
					{Name = "Wooden - Ornate",Template = "furniture_chair_ornate" },
					{Name = "Wooden",Template = "furniture_chair_wooden" },
					{Name = "Throne - Reaper",Template = "furniture_throne_reaper" },
					{Name = "Stool - Large Light Stained",Template = "furniture_stool_inn_dark" },
					{Name = "Stool - Large Dark Stained",Template = "furniture_stool_inn" },
					{Name = "Stool - Small Light Stained",Template = "furniture_stool_wooden_dark" },
					{Name = "Stool - Small Dark Stained",Template = "furniture_stool_wooden" },
					{Name = "Bench - Brick & Board",Template = "furniture_bench_celador" },
					{Name = "Bench - Fancy",Template = "furniture_bench_fancy" },
					{Name = "Bench - Simple",Template = "furniture_bench_stage" },
					{Name = "Bench - Stone",Template = "furniture_bench_stone" },
					{Name = "Bench - Church",Template = "furniture_church_bench" },
					{Name = "Bench - Giant",Template = "giant_bench" },
				},
			},			
			{
				Name = "Craft Benches",
				Templates =
				{
					{Name = "Blacksmiths Anvil",Template = "tool_anvil" },
					{Name = "Carpenters Bench",Template = "tool_carpentry_table" },
					{Name = "Blacksmiths Forge - Long",Template = "tool_forge" },
					{Name = "Blacksmiths Forge - Bone",Template = "tool_forge_bone" },
					{Name = "Blacksmiths Forge - Round",Template = "tool_forge_round" },
					{Name = "Fabricators Loom",Template = "tool_loom" },
					{Name = "Alchemists Workbench",Template = "workbench_alchemy" },
					{Name = "Fabricators Loom - Bone",Template = "workbench_fabrication_bone_table" },
					{Name = "Carpenters Bench - Bone And Stone",Template = "workbench_woodsmith_bone_table" },
					{Name = "Scribes Bench",Template = "workbench_inscription" },
					{Name = "Cooks Stove",Template = "stove" },
				},
			},
			{
				Name = "Beds",
				Templates =
				{
					{Name = "Wooden Blue Large",Template = "bed_wooden_arches_large_blank" },
					{Name = "Wooden Canopy Orange",Template = "bed_wooden_canopy_small_blank" },
					{Name = "Wooden Blue Small",Template = "bed_wooden_rusitc_small_blank" },
					{Name = "Wooden Red Large",Template = "furniture_bed_large" },
					{Name = "Wooden Blue Medium",Template = "furniture_bed_medium" },
					{Name = "Bed Roll",Template = "furniture_bed_roll" },
					{Name = "Wooden Messy Small",Template = "furniture_bed_small" },
					{Name = "Cot",Template = "furniture_bed_soldiers_cot" },
				},
			},						
		},
	}
}

CreationMenu.Decorations=
{
	{
		Name = "Decorations",
		DoDecorationTool = true,
		Categories =
		{
			{
				Name = "Graveyard",
				Templates =
				{
					{Name = "Coffin 1",Template = "coffin01" },
					{Name = "Coffin 2",Template = "coffin02" },
					{Name = "Coffin 3",Template = "coffin03" },
					{Name = "Coffin 4",Template = "coffin04" },
					{Name = "Coffin 5",Template = "coffin05" },
					{Name = "Coffin 6",Template = "coffin06" },
					{Name = "Coffin 7",Template = "coffin07" },
					{Name = "Coffin 8",Template = "coffin08" },
					{Name = "Coffin 9",Template = "coffin09" },
					{Name = "Gravestone - Ceremonial",Template = "gravestone_ceremonial" },
					{Name = "Gravestone - Cracked",Template = "gravestone_cracked" },
					{Name = "Gravestone - Curved",Template = "gravestone_curved" },
					{Name = "Gravestone - Flat",Template = "gravestone_flat" },
					{Name = "Gravestone - Pillar",Template = "gravestone_pillar" },
					{Name = "Gravestone - Tipped",Template = "gravestone_tipped" },
					{Name = "Gravestone - Topped",Template = "gravestone_topped" },
					{Name = "Gravestone - Uncracked",Template = "gravestone_uncracked" },
				},				
			},
			{
				Name = "Market Stalls",
				Templates =
				{
					{Name = "Market Stall - Canopy Blue",Template = "furniture_market_stall" },
					{Name = "Market Stall - Canopy Red And White",Template = "furniture_square_market_stall" },
					{Name = "Market Stall - Tent Green And Yellow",Template = "furniture_tent_market_stall" },
					{Name = "Market Stall - Counter Angled",Template = "market_stall_counter_angled_small_blank" },
					{Name = "Market Stall - Counter Basic",Template = "market_stall_counter_basic_medium_blank" },
					{Name = "Market Stall - Counter Curved",Template = "market_stall_counter_cloth_curved_blank" },
					{Name = "Market Stall - Counter Plank",Template = "market_stall_counter_plank_blank" },
					{Name = "Market Stall - Counter Angled Large",Template = "market_stall_counter_tiered_large_blank" },
					{Name = "Market Stall - Counter Angled Small",Template = "market_stall_counter_tiered_medium_blank" },
					{Name = "Market Stall - Wagon",Template = "market_stall_top_10_blank" },
					{Name = "Market Stall - Canopy Wooden",Template = "marketstall_top_5_blank" },
					{Name = "Market Stall - Canopy Wooden Canvas",Template = "marketstall_top_9_blank" },
				},				
			},
			{
				Name = "Potted Plants",
				Templates =
				{
					{Name = "Berry Plant",Template = "item_potted_plant_berry" },
					{Name = "Berry Plant Box",Template = "item_potted_plant_bush" },
					{Name = "Hedge",Template = "item_potted_plant_hedge" },
					{Name = "Long Leaf",Template = "item_potted_plant_longleaf" },
					{Name = "Round Bush",Template = "item_potted_plant_round_bush" },
					{Name = "Tree",Template = "item_potted_plant_tree" },
					{Name = "White Rose",Template = "item_potted_plant_white_rose" },
					{Name = "Hanging Flowers White",Template = "item_potted_plant_blue_flowers_blank" },
					{Name = "Plant Box Blue White",Template = "potted_plant_flower_box_blue_blank" },
					{Name = "Hanging Fern",Template = "potted_plant_hanging_fern_blank" },
				},				
			},						
		},
	}
}

-- sort all the sub category template tables


for k,v in pairs(CreationMenu.Structures[1].Categories) do
	table.sort(v.Templates,function (a,b)
		return a.Name < b.Name
	end)
end

for k,v in pairs(CreationMenu.Lighting[1].Categories) do
	table.sort(v.Templates,function (a,b)
		return a.Name < b.Name
	end)
end

for k,v in pairs(CreationMenu.Equipment[1].Categories) do
	table.sort(v.Templates,function (a,b)
		return a.Name < b.Name
	end)
end

for k,v in pairs(CreationMenu.Resources[1].Categories) do
	table.sort(v.Templates,function (a,b)
		return a.Name < b.Name
	end)
end

for k,v in pairs(CreationMenu.Furniture[1].Categories) do
	table.sort(v.Templates,function (a,b)
		return a.Name < b.Name
	end)
end

for k,v in pairs(CreationMenu.Decorations[1].Categories) do
	table.sort(v.Templates,function (a,b)
		return a.Name < b.Name
	end)
end

-- sort all the categories by name
for k,v in pairs(CreationMenu) do
	table.sort(v[1].Categories,function (a,b)
		return a.Name < b.Name
	end)
end

ObjectTemplateToPlace = nil
MenuType = nil
SubCategory = nil

function GetSubCategoryTable(menuType,subCategory)
	local creationMenuTable = CreationMenu[menuType][1].Categories
	for subCategoryIndex,subCategoryValue in pairs(creationMenuTable) do
		if(subCategoryValue.Name==subCategory) then return subCategoryValue end
	end

	return nil
end

function ShowCreationMenu(user,menuType,subCategory)
	menuType = menuType or "Structures"
	subCategory = subCategory or "Stone"
	MenuType = menuType
	SubCategory = subCategory
	-- create local objects and variables
	local dynamicWindow = DynamicWindow("CreationMenuWindow","",500,630,275,210,"TransparentDraggable","Center")
	local scrollWindow = ScrollWindow(225,45,250,380,20)
	local scrollElement = nil    
	local creationMenuTable = CreationMenu[menuType][1]
	local categories = creationMenuTable.Categories
    local subCategories = GetSubCategoryTable(menuType,subCategory)

    -- create the main background window
    dynamicWindow:AddImage(1,1,"HueSwatch",500,630,"Simple","252535")
    dynamicWindow:AddImage(3,3,"HueSwatch",494,624,"Simple","151525")
    -- create the header background and text
    dynamicWindow:AddImage(1,1,"HueSwatch",500,34,"Simple","353545")
    dynamicWindow:AddImage(-2,-2,"CraftingItemsFrame",506,40,"Sliced","557575")
    dynamicWindow:AddLabel(245,10,"[959555]" .. creationMenuTable.Name .. " - " .. subCategory,330,20,20,"center")	
    --show categories
    y = 20
    local categoryTextColor = "[959555]"
    if(categories) then
    	for categoryIndex,categoryValue in pairs(categories) do
    		y = y + 30
    		if(categoryValue.Name == subCategory) then categoryTextColor = "[FF7700]" end
    		dynamicWindow:AddImage(10,y,"HueSwatch",200,25,"Simple","252535")
    		dynamicWindow:AddImage(13,y+2,"HueSwatch",194,19,"Simple","202030")    		
    		dynamicWindow:AddLabel(20,y+4,categoryTextColor .. categoryValue.Name,190,20,20,"left")
    		dynamicWindow:AddButton(10,y,"ChangeCategory|"..menuType.."|"..categoryValue.Name,"",200,20,"Select the [EEEE44]"..categoryValue.Name .. "[-] category","",false,"Invisible")
    		categoryTextColor = "[959555]"
    	end
    end
    local switchcolors = true
    local color = "252535"
    --show categories
    if(subCategories) then
    	for categoryIndex,categoryValue in pairs(subCategories.Templates) do
    		scrollElement = ScrollElement()
		    if(switchcolors== false) then
		        color="252535"
		    else
		        color="151525"
		    end    		
    		scrollElement:AddImage(0,0,"HueSwatch",230,20,"Simple",color)
    		scrollElement:AddLabel(6,2,"[959555]" .. categoryValue.Name,230,16,16,"left")
    		scrollElement:AddButton(0,0,"PlaceItem|"..categoryValue.Template.."|"..categoryValue.Name,"",235,20,"Click to place " .. categoryValue.Name,"",false,"Invisible")
    		scrollWindow:Add(scrollElement)
    		switchcolors = not switchcolors 
    	end
    end
	--attach the scrollWindow object to the dynamic window
	dynamicWindow:AddScrollWindow(scrollWindow)
	-- draw the close button on the dynamic window
	DrawCloseButton(471,9,dynamicWindow)

	-- start of decoration toolbar
    dynamicWindow:AddImage(1,431,"HueSwatch",500,34,"Simple","353545")
    dynamicWindow:AddImage(-2,429,"CraftingItemsFrame",506,40,"Sliced","557575")
    dynamicWindow:AddLabel(245,440,"[959555] Decoration Toolbar",330,20,20,"center")

    if(user:HasObjVar("WorldBuilder.DecorationTarget")) then
		local objRef = user:GetObjVar("WorldBuilder.DecorationTarget")
		dynamicWindow:AddLabel(245,465,"[959555]"..objRef:GetCreationTemplateId(),330,20,20,"center")    	    	

		dynamicWindow:AddImage(15,490,"HueSwatch",30,20,"Simple","252535")
		dynamicWindow:AddImage(17,492,"HueSwatch",26,16,"Simple","202030")
    	dynamicWindow:AddLabel(28,493,"[959555]+1",30,18,18,"center")
    	dynamicWindow:AddButton(15,490,"RotateObject|1","",30,20,"[EEEE44]Click to rotate the object by 1 degrees clockwise","",false,"Invisible")

		dynamicWindow:AddImage(50,490,"HueSwatch",30,20,"Simple","252535")
		dynamicWindow:AddImage(52,492,"HueSwatch",26,16,"Simple","202030")
    	dynamicWindow:AddLabel(63,493,"[959555]+12",30,18,18,"center")
    	dynamicWindow:AddButton(50,490,"RotateObject|12","",30,20,"[EEEE44]Click to rotate the object by 12 degrees clockwise","",false,"Invisible")

		dynamicWindow:AddImage(85,490,"HueSwatch",30,20,"Simple","252535")
		dynamicWindow:AddImage(87,492,"HueSwatch",26,16,"Simple","202030")
    	dynamicWindow:AddLabel(98,493,"[959555]+20",30,18,18,"center")
    	dynamicWindow:AddButton(85,490,"RotateObject|20","",30,20,"[EEEE44]Click to rotate the object by 20 degrees clockwise","",false,"Invisible")

		dynamicWindow:AddImage(120,490,"HueSwatch",30,20,"Simple","252535")
		dynamicWindow:AddImage(122,492,"HueSwatch",26,16,"Simple","202030")
    	dynamicWindow:AddLabel(133,493,"[959555]+30",30,18,18,"center")
    	dynamicWindow:AddButton(120,490,"RotateObject|30","",30,20,"[EEEE44]Click to rotate the object by 30 degrees clockwise","",false,"Invisible")

		dynamicWindow:AddImage(155,490,"HueSwatch",30,20,"Simple","252535")
		dynamicWindow:AddImage(157,492,"HueSwatch",26,16,"Simple","202030")
    	dynamicWindow:AddLabel(168,493,"[959555]+45",30,18,18,"center")
    	dynamicWindow:AddButton(155,490,"RotateObject|45","",30,20,"[EEEE44]Click to rotate the object by 45 degrees clockwise","",false,"Invisible")

		dynamicWindow:AddImage(190,490,"HueSwatch",30,20,"Simple","252535")
		dynamicWindow:AddImage(192,492,"HueSwatch",26,16,"Simple","202030")
    	dynamicWindow:AddLabel(203,493,"[959555]+60",30,18,18,"center")
    	dynamicWindow:AddButton(190,490,"RotateObject|60","",30,20,"[EEEE44]Click to rotate the object by 60 degrees clockwise","",false,"Invisible")

		dynamicWindow:AddImage(225,490,"HueSwatch",30,20,"Simple","252535")
		dynamicWindow:AddImage(227,492,"HueSwatch",26,16,"Simple","202030")
    	dynamicWindow:AddLabel(238,493,"[959555]+90",30,18,18,"center")
    	dynamicWindow:AddButton(225,490,"RotateObject|90","",30,20,"[EEEE44]Click to rotate the object by 90 degrees clockwise","",false,"Invisible")

		dynamicWindow:AddImage(260,490,"HueSwatch",30,20,"Simple","252535")
		dynamicWindow:AddImage(262,492,"HueSwatch",26,16,"Simple","202030")
    	dynamicWindow:AddLabel(273,493,"[959555]-90",30,18,18,"center")
    	dynamicWindow:AddButton(260,490,"RotateObject|-90","",30,20,"[EEEE44]Click to rotate the object by 90 degrees counter clockwise","",false,"Invisible")

		dynamicWindow:AddImage(295,490,"HueSwatch",30,20,"Simple","252535")
		dynamicWindow:AddImage(297,492,"HueSwatch",26,16,"Simple","202030")
    	dynamicWindow:AddLabel(308,493,"[959555]-60",30,18,18,"center")
    	dynamicWindow:AddButton(295,490,"RotateObject|-60","",30,20,"[EEEE44]Click to rotate the object by 60 degrees counter clockwise","",false,"Invisible")

		dynamicWindow:AddImage(330,490,"HueSwatch",30,20,"Simple","252535")
		dynamicWindow:AddImage(332,492,"HueSwatch",26,16,"Simple","202030")
    	dynamicWindow:AddLabel(343,493,"[959555]-45",30,18,18,"center")
    	dynamicWindow:AddButton(330,490,"RotateObject|-45","",30,20,"[EEEE44]Click to rotate the object by 45 degrees counter clockwise","",false,"Invisible")    	

		dynamicWindow:AddImage(365,490,"HueSwatch",30,20,"Simple","252535")
		dynamicWindow:AddImage(367,492,"HueSwatch",26,16,"Simple","202030")
    	dynamicWindow:AddLabel(378,493,"[959555]-30",30,18,18,"center")
    	dynamicWindow:AddButton(365,490,"RotateObject|-30","",30,20,"[EEEE44]Click to rotate the object by 30 degrees counter clockwise","",false,"Invisible") 

		dynamicWindow:AddImage(390,490,"HueSwatch",30,20,"Simple","252535")
		dynamicWindow:AddImage(392,492,"HueSwatch",26,16,"Simple","202030")
    	dynamicWindow:AddLabel(403,493,"[959555]-20",30,18,18,"center")
    	dynamicWindow:AddButton(390,490,"RotateObject|-20","",30,20,"[EEEE44]Click to rotate the object by 20 degrees counter clockwise","",false,"Invisible")     	

		dynamicWindow:AddImage(425,490,"HueSwatch",30,20,"Simple","252535")
		dynamicWindow:AddImage(427,492,"HueSwatch",26,16,"Simple","202030")
    	dynamicWindow:AddLabel(438,493,"[959555]-12",30,18,18,"center")
    	dynamicWindow:AddButton(425,490,"RotateObject|-12","",30,20,"[EEEE44]Click to rotate the object by 12 degrees counter clockwise","",false,"Invisible")

		dynamicWindow:AddImage(460,490,"HueSwatch",30,20,"Simple","252535")
		dynamicWindow:AddImage(462,492,"HueSwatch",26,16,"Simple","202030")
    	dynamicWindow:AddLabel(473,493,"[959555]-1",30,18,18,"center")
    	dynamicWindow:AddButton(460,490,"RotateObject|-1","",30,20,"[EEEE44]Click to rotate the object by 1 degrees counter clockwise","",false,"Invisible")     	     	

    else
		dynamicWindow:AddImage(225,490,"HueSwatch",50,20,"Simple","252535")
		dynamicWindow:AddImage(227,492,"HueSwatch",46,16,"Simple","202030")
    	dynamicWindow:AddLabel(250,493,"[959555]Select",50,18,18,"center")
    	dynamicWindow:AddButton(225,490,"SelectDecoTarget|","",50,20,"[EEEE44]Click here and select a target decoration to modify","",false,"Invisible")   	    	
    end
	-- open up the finalized dynamic window for the user
	user:OpenDynamicWindow(dynamicWindow,user)
end

--- this will draw the close button on a dynamic window
-- @param x - this is the x location to draw the close button at
-- @param y - this is the y location to draw the close button at
-- @param dynamicWindow - this is the dynamic window to attach the close button too
function DrawCloseButton(x,y,dynamicWindow)
	--border background color
	dynamicWindow:AddImage(x,y,"Blank",18,18,"Sliced","555555")
	--background color
	dynamicWindow:AddImage(x+2,y+2,"Blank",14,14,"Sliced","252525")
	--invisible button
	dynamicWindow:AddButton(x,y,"CloseButton|ParentForm","",18,18,"[CCCC33]Close Button\n[FFFFFF]clicking this will close the window.","",true,"Invisible")
	--draw the "X" string
	dynamicWindow:AddLabel(x+5,y+3,"[959555]X",18,18,18,"left")
end

function HandleCreationMenuWindowResponse(user,buttonId,textField)
	local args = StringSplit(buttonId, "|")
	local button = args[1]
	if(button == "ChangeCategory") then
		local category = args[2]
		local subCategory = args[3]
		ShowCreationMenu(this,category,subCategory)
	end
	if(button=="PlaceItem") then
		ObjectTemplateToPlace = args[2]
		this:SystemMessage("select a location to place this object")
		this:RequestClientTargetLocPreview(this, "CreateMenuTarget",args[2],Loc(0,0,0),Loc(1,1,1))
	end
	if(button=="CloseButton") then
		user:DelObjVar("WorldBuilder.DecorationTarget")
	end
	if(button=="RotateObject") then
		local rotationChange = tonumber(args[2]) or 0
		local objRef = user:GetObjVar("WorldBuilder.DecorationTarget")
		local objRotation = objRef:GetRotation()
		objRotation.Y = objRotation.Y + rotationChange 
		objRef:SetRotation(objRotation)
		ShowCreationMenu(this,MenuType,SubCategory)
	end
	if(button=="SelectDecoTarget") then
		user:RequestClientTargetGameObj(user, "SelectDecoTarget")
		user:SystemMessage("select a item to modify")
	end
end

function HandleCreateTargetLocation(success,targetLoc,targetObj,user)
	if(success and targetLoc) then
		CreateObj(ObjectTemplateToPlace,targetLoc,"MenuItemCreated")
	end
end

function HandleMenuItemCreated(success, objRef)
	if(success and objRef) then
		-- if(objRef:HasModule("stackable")) then
		-- 	objRef:SendMessage("SetStackCount",100)
		-- end
		if(objRef:HasSharedObjectProperty("Weight")) then
			objRef:SetSharedObjectProperty("Weight", -1)
		end
		SetItemTooltip(objRef)
		objRef:SetObjVar("NoReset",true)
		objRef:SetObjVar("IsSeedObject",true)
		this:SetObjVar("WorldBuilder.DecorationTarget",objRef)
		ShowCreationMenu(this,MenuType,SubCategory)
	end
end

function HandleCreationProfileSpawnerResponse(success, objRef)
	if(success and objRef) then
		objRef:SetObjVar("NoReset",true)
		objRef:SetObjVar("IsSeedObject",true)
	end
end

function HandleSelectDecoTarget(target,user)
	if(target) then
		user:SetObjVar("WorldBuilder.DecorationTarget",target)
		ShowCreationMenu(user,MenuType,SubCategory)
	end
end

RegisterEventHandler(EventType.DynamicWindowResponse,"CreationMenuWindow", HandleCreationMenuWindowResponse)
RegisterEventHandler(EventType.CreatedObject,"ProfileSpawnerCreated", HandleCreationProfileSpawnerResponse)
RegisterEventHandler(EventType.ClientTargetLocResponse, "CreateMenuTarget", HandleCreateTargetLocation) 
RegisterEventHandler(EventType.CreatedObject, "MenuItemCreated", HandleMenuItemCreated)
RegisterEventHandler(EventType.ClientTargetGameObjResponse, "SelectDecoTarget", HandleSelectDecoTarget)

RegisterEventHandler(EventType.ClientUserCommand, "CreateProfileSpawner", function ()
	CreateObj("profile_spawner",this:GetLoc(),"ProfileSpawnerCreated")
end)
RegisterEventHandler(EventType.ClientUserCommand, "ToggleShowCreateStructures", function ()
	ShowCreationMenu(this,"Structures","Doors")
end)
RegisterEventHandler(EventType.ClientUserCommand, "ToggleShowCreateLighting", function ()
	ShowCreationMenu(this,"Lighting","Fires")
end)
RegisterEventHandler(EventType.ClientUserCommand, "ToggleShowCreateEquipment", function ()
	ShowCreationMenu(this,"Equipment","Armor")
end)
RegisterEventHandler(EventType.ClientUserCommand, "ToggleShowCreateResources", function ()
	ShowCreationMenu(this,"Resources","Cloth")
end)
RegisterEventHandler(EventType.ClientUserCommand, "ToggleShowCreateFurniture", function ()
	ShowCreationMenu(this,"Furniture","Beds")
end)
RegisterEventHandler(EventType.ClientUserCommand, "ToggleShowCreateDecorations", function ()
	ShowCreationMenu(this,"Decorations","Graveyard")
end)
RegisterEventHandler(EventType.ClientUserCommand, "DoReloadGlobals", function ()
	this:SystemMessage("Reloading Globals please wait...")
	ChangeWorld(true)
end)
RegisterEventHandler(EventType.ClientUserCommand, "DoReloadTemplates", function ()
	this:SystemMessage("Reloading Templates please wait...")
	ReloadTemplates()
end)

