MobileEffectLibrary.Disenchanting = 
{
	CurrencyTable = {},
	OnEnterState = function(self,root,target,args)
		self.RequestInitialTarget(self,root,target,args)			
	end,
	RequestInitialTarget = function(self,root,target,args)
		RegisterEventHandler(EventType.ClientTargetGameObjResponse, "DisenchantingMobileEffectTarget", function (targetObj,user)
			if ( targetObj and targetObj:HasObjVar("Enchants")) then
				self.ProcessDisenchant(self,root,targetObj)				
			else
				self.ParentObj:SystemMessage("you can not disenchant this object")
				EndMobileEffect(root)
			end
		end)
		RegisterEventHandler(EventType.CreatedObject, "CreateDisenchantedItem", function (success,objRef,amount)
			if(objRef:HasModule("stackable")) then
				local stackCount = objRef:GetObjVar("StackCount") or 1
				stackCount = stackCount + amount
				objRef:SetObjVar("StackCount",stackCount)
				TryStack(objRef, self.ParentObj:GetEquippedObject("Backpack"), false, true)
				--self.ParentObj:SystemMessage("you salvaged " .. amount .. " " .. objRef:GetName(),"event")
			end
			self.ParentObj:SystemMessage("you create a "..objRef:GetName())
		end)		
		self.ParentObj:RequestClientTargetGameObj(self.ParentObj, "DisenchantingMobileEffectTarget")
	end,
	DetermineResourceAmount = function(self,root,target)
		local amountToGive = 0
		local craftSkillValue = 0
		local skillLevel = GetSkillLevel(self.ParentObj,"DisenchantingSkill")
		local propertyBonus = 0
		amountToGive = amountToGive + math.random(1,#target:GetObjVar("Enchants"))
		if(skillLevel >= 100) then amountToGive = amountToGive + 1 end	
		return math.random(1, amountToGive)
	end,
	ProcessDisenchant = function(self,root,target)	
		if(IsInBackpack(target,self.ParentObj)) then
			if(target) then
				-- update create method so resources stack in the backpack
				CheckSkillChance(self.ParentObj, "DisenchantingSkill", GetSkillLevel(self.ParentObj,"DisenchantingSkill"),SkillValueMinMax(GetSkillLevel(self.ParentObj,"DisenchantingSkill"), 0, 100))		
				local chance = 0.25 + (GetSkillLevel(self.ParentObj,"DisenchantingSkill")/200)
				if(math.random() <= chance) then
					self.ParentObj:SystemMessage("you succeed in disenchanting this object")
					local amountOfResources = self.DetermineResourceAmount(self,root,target)
					CreateObjInBackpackOrAtLocation(self.ParentObj, "resource_essence", "CreateDisenchantedItem",amountOfResources)				
					self.GenerateCurrencyTable(self,root,target)
					if(#self.CurrencyTable > 0) then
						self.ProcessCurrency(self,root,target)
					end
				else
					self.ParentObj:SystemMessage("you fail to produce anything from disenchanting this item")	
				end
				target:Destroy()
			else
				self.ParentObj:SystemMessage("this item can not be disenchanted")
			end
		else
			self.ParentObj:SystemMessage("this item must be in your backpack to salvage")
		end
		--when done end it
		EndMobileEffect(root)
	end,
	ProcessCurrency = function(self,root,target)
		for k,v in pairs(self.CurrencyTable) do
			CreateObjInBackpackOrAtLocation(self.ParentObj, v, "CreateDisenchantedItem",1)
		end
	end,
	GenerateCurrencyTable = function(self,root,target)
		if(math.random(1,10) == 6) then table.insert(self.CurrencyTable,"gem_of_transmogrification") end
		if(math.random(1,20) == 13) then table.insert(self.CurrencyTable,"gem_of_alteration") end
		if(math.random(1,30) == 22) then table.insert(self.CurrencyTable,"gem_of_alchemy") end
		if(math.random(1,40) == 36) then table.insert(self.CurrencyTable,"gem_of_chaos") end
		if(math.random(1,60) == 46) then table.insert(self.CurrencyTable,"gem_of_regal") end
		if(math.random(1,80) == 66) then table.insert(self.CurrencyTable,"gem_of_exalted") end
	end,
}