SpawnerProfile.RandomMoroseGraveyardSkeleton =
{
	ProfileName = "Morose Graveyard Skeletons (random)",
	ProfileTooltip = "This setup is for the morose graveyard spawn west of the landing. It has 5 skeletons that can spawn 1 at a time.",
	-- randomly generate from this list a creature to on respawn
	Templates = 
	{
		"morose_skeleton_archer",
		"morose_skeleton_slasher",
		"morose_skeleton_basher",
		"morose_skeleton_piercer",
		"morose_skeleton_lancing",
	},
	-- how often to respawn
	Frequency = SpawnDelayRules.Slow,
	-- chance in which to spawn the object from the Templates table
	SpawnChance = 1.0,
	-- how many do we spawn at this location?
	SpawnCount = 1,
	-- loot table overrides the original templates LootTable objvar
	LootTables = 
	{
		["morose_skeleton_archer"] = 
		{
			TemplateDefines.LootTable.CurrencyLow,
			TemplateDefines.LootTable.ArcheryWeapons,
			TemplateDefines.LootTable.ArrowsLow,
			TemplateDefines.LootTable.ChainArmor,
			TemplateDefines.LootTable.LeatherArmor,   
			TemplateDefines.LootTable.PaddedArmor,
			TemplateDefines.LootTable.ArcheryWeapons,
			TemplateDefines.LootTable.CurrencyGems,
		},
		["morose_skeleton_slasher"] = 
		{
			TemplateDefines.LootTable.CurrencyLow,
			TemplateDefines.LootTable.ArcheryWeapons,
			TemplateDefines.LootTable.ChainArmor,
			TemplateDefines.LootTable.LeatherArmor,
			TemplateDefines.LootTable.PaddedArmor,
			TemplateDefines.LootTable.SlashingWeapons,
			TemplateDefines.LootTable.ReagentsLow,
			TemplateDefines.LootTable.CurrencyGems,
		},
		["morose_skeleton_basher"] = 
		{
			TemplateDefines.LootTable.CurrencyLow,
			TemplateDefines.LootTable.ArcheryWeapons,
			TemplateDefines.LootTable.ChainArmor,
			TemplateDefines.LootTable.LeatherArmor,
			TemplateDefines.LootTable.PaddedArmor,
			TemplateDefines.LootTable.BashingWeapons,
			TemplateDefines.LootTable.ReagentsLow,
			TemplateDefines.LootTable.CurrencyGems,
		},
		["morose_skeleton_piercer"] = 
		{
			TemplateDefines.LootTable.CurrencyLow,
			TemplateDefines.LootTable.ArcheryWeapons,
			TemplateDefines.LootTable.ChainArmor,
			TemplateDefines.LootTable.LeatherArmor,
			TemplateDefines.LootTable.PaddedArmor,
			TemplateDefines.LootTable.PiercingWeapons,
			TemplateDefines.LootTable.ReagentsLow,
			TemplateDefines.LootTable.CurrencyGems,
		},
		["morose_skeleton_lancing"] = 
		{
			TemplateDefines.LootTable.CurrencyLow,
			TemplateDefines.LootTable.ArcheryWeapons,
			TemplateDefines.LootTable.ChainArmor,
			TemplateDefines.LootTable.LeatherArmor,
			TemplateDefines.LootTable.PaddedArmor,
			TemplateDefines.LootTable.LancingWeapons,
			TemplateDefines.LootTable.ReagentsLow,
			TemplateDefines.LootTable.CurrencyGems,
		},	
	}
}

