SpawnerProfile.RandomSnarlFangGoblin =
{
	ProfileName = "Snarlfang Goblin",
	ProfileTooltip = "This setup is for the snarlfang goblin camp just north of the landing. It has 5 goblins that can spawn 1 at a time.",
	-- randomly generate from this list a creature to on respawn
	Templates = 
	{
		"snarlfang_goblin_archer",
		"snarlfang_goblin_slasher",
		"snarlfang_goblin_basher",
		"snarlfang_goblin_piercer",
		"snarlfang_goblin_lancing",
	},
	-- how often to respawn
	Frequency = SpawnDelayRules.Slow,
	-- chance in which to spawn the object from the Templates table
	SpawnChance = 1.0,
	-- how many do we spawn at this location?
	SpawnCount = 1,
	-- how often to spawn a special object from the RareSpawnTemplates table
	RareSpawnChance = 0.01,
	-- randomly generate from this list a creature to spawn instead of the normal spawn
	RareSpawnTemplates =
	{
		"snarlfang_goblin_weaponsmith",
		"snarlfang_goblin_armorsmith",  
	},
	-- loot table overrides the original templates LootTable objvar
	LootTables = 
	{
		["snarlfang_goblin_archer"] = 
		{
			TemplateDefines.LootTable.CurrencyLow,
			TemplateDefines.LootTable.ArcheryWeapons,
			TemplateDefines.LootTable.ArrowsLow,
			TemplateDefines.LootTable.ChainArmor,
			TemplateDefines.LootTable.LeatherArmor,   
			TemplateDefines.LootTable.PaddedArmor,
			TemplateDefines.LootTable.ArcheryWeapons,
			TemplateDefines.LootTable.CurrencyGems,
		},
		["snarlfang_goblin_slasher"] = 
		{
			TemplateDefines.LootTable.CurrencyLow,
			TemplateDefines.LootTable.ArcheryWeapons,
			TemplateDefines.LootTable.ChainArmor,
			TemplateDefines.LootTable.LeatherArmor,
			TemplateDefines.LootTable.PaddedArmor,
			TemplateDefines.LootTable.SlashingWeapons,
			TemplateDefines.LootTable.CurrencyGems,
			TemplateDefines.LootTable.ReagentsLow,
		},
		["snarlfang_goblin_basher"] = 
		{
			TemplateDefines.LootTable.CurrencyLow,
			TemplateDefines.LootTable.ArcheryWeapons,
			TemplateDefines.LootTable.ChainArmor,
			TemplateDefines.LootTable.LeatherArmor,
			TemplateDefines.LootTable.PaddedArmor,
			TemplateDefines.LootTable.BashingWeapons,
			TemplateDefines.LootTable.ReagentsLow,
			TemplateDefines.LootTable.CurrencyGems,
		},
		["snarlfang_goblin_piercer"] = 
		{
			TemplateDefines.LootTable.CurrencyLow,
			TemplateDefines.LootTable.ArcheryWeapons,
			TemplateDefines.LootTable.ChainArmor,
			TemplateDefines.LootTable.LeatherArmor,
			TemplateDefines.LootTable.PaddedArmor,
			TemplateDefines.LootTable.PiercingWeapons,
			TemplateDefines.LootTable.ReagentsLow,
			TemplateDefines.LootTable.CurrencyGems,
		},
		["snarlfang_goblin_lancing"] = 
		{
			TemplateDefines.LootTable.CurrencyLow,
			TemplateDefines.LootTable.ArcheryWeapons,
			TemplateDefines.LootTable.ChainArmor,
			TemplateDefines.LootTable.LeatherArmor,
			TemplateDefines.LootTable.PaddedArmor,
			TemplateDefines.LootTable.LancingWeapons,
			TemplateDefines.LootTable.ReagentsLow,
			TemplateDefines.LootTable.CurrencyGems,
		},
		-- RARE MOBS									
		["snarlfang_goblin_weaponsmith"] =
		{
			TemplateDefines.LootTable.CurrencyMed,
			TemplateDefines.LootTable.LancingWeaponRecipes,			
			TemplateDefines.LootTable.PiercingWeaponRecipes,			
			TemplateDefines.LootTable.BashingWeaponRecipes,			
			TemplateDefines.LootTable.SlashingWeaponRecipes,					
			TemplateDefines.LootTable.ReagentsMed,
			TemplateDefines.LootTable.CurrencyGems,
			TemplateDefines.LootTable.CurrencyGems,
		},	
		["snarlfang_goblin_armorsmith"] =
		{
			TemplateDefines.LootTable.CurrencyMed,
			TemplateDefines.LootTable.ClothArmorRecipes,								
			TemplateDefines.LootTable.LeatherArmorRecipes,								
			TemplateDefines.LootTable.MetalArmorRecipes,								
			TemplateDefines.LootTable.ReagentsMed,
			TemplateDefines.LootTable.CurrencyGems,
			TemplateDefines.LootTable.CurrencyGems,
		}		
	}
}

