require 'incl_magic_sys'

function ValidateUse(user)
	if( user == nil or not(user:IsValid()) ) then
		return false
	end
	if( this:TopmostContainer() ~= user or IsInBank(this)) then
		user:SystemMessage("The scroll must be in your backpack before you can use it.","info")
		return false
	end

	if not(this:HasObjVar("Spell")) then 
		user:SystemMessage("Invalid scroll, no spell set.","info")
		return false
	end

	return true
end

RegisterEventHandler(EventType.Message, "UseObject", 
	function(user,usedType)
		if not(ValidateUse(user)) then
			return
		end
		local spell = this:GetObjVar("Spell")
		local magicKnowledge = user:GetObjVar("MagicKnowledge") or {}
		local skillKey = SpellData.AllSpells[spell].Skill
		
		for k,v in pairs(magicKnowledge[skillKey]) do
			if(v==spell) then
				user:SystemMessage("you already have this spell.")
				return
			end
		end

		table.insert(magicKnowledge[skillKey],spell)
		user:SetObjVar("MagicKnowledge",magicKnowledge)
		user:SystemMessage("you learn how to cast this spell.")
		this:Destroy()
	end)
               