-----------------------------------------------------------------------------------------------
-- VERSION 1.0
-----------------------------------------------------------------------------------------------
-- Damage Scaling
-- TODO DAMANGE CHANGE COMMENT CORRECTLY
-- damage bonus is 1 - 100 based on enhancement skill
-- RULES
-- 50% less damage to non undead
-----------------------------------------------------------------------------------------------
MobileEffectLibrary.FlameWhirl = 
{
	-------------------------------------------------------------------------------------------
	-- CORE VARIABLES
	-------------------------------------------------------------------------------------------
	Duration = SpellData.SpellEffectDuration.Instant,
	MinDamage = 9,
	MaxDamage = 18,
	BaseDamage = 15,
	Caster = nil,
	Victim = nil,
	LeechEfficacy =
	{
		Health = 0.035,
		Mana = 0.025,
		Stamina = 0.03,
	},	
	-------------------------------------------------------------------------------------------
	-- CORE FUNCTIONS
	-------------------------------------------------------------------------------------------
	OnEnterState = function(self,root,target,args)
		self.Caster = target
		self.Victim = self.ParentObj
		self.PlayEffects(self,root,target,args)
	end,
	GetPulseFrequency = function(self,root)
		return self.Duration
	end,
	AiPulse = function(self,root)
		EndMobileEffect(root)
	end,
	-------------------------------------------------------------------------------------------
	-- CUSTOM FUNCTIONS
	-------------------------------------------------------------------------------------------
	PlayEffects = function(self,root,target,args)
		DoProjectileSpellEffects(self.Caster,self.Victim,"FlameWhirl",self)
	end,
	DoDelayedDamage = function (self)
		local baseFireDamage = (GetSkillLevel(self.Caster,"PyromancySkill")/100) * self.BaseDamage
		local spellDamage = math.random(self.MinDamage,self.MaxDamage) + baseFireDamage
		if(self.Caster:IsPlayer()) then
			spellDamage = spellDamage + (GetCachedMobileModByName("DamageBonusSpellFlameWhirl",self.Caster) or 0)			
		end		
		self.Victim:SendMessage("DamageInflicted",self.Caster,spellDamage,"MAGIC",false,false,false,self.Caster)
		self.CheckLeechEffects(self,root)
	end,
	CheckLeechEffects = function(self,root)
		local lifeLeech = GetCachedMobileModByName("OnHitSpellFireballLeechHealth",self.Caster) or 0
		local manaLeech = GetCachedMobileModByName("OnHitSpellFireballLeechMana",self.Caster) or 0
		local staminaLeech = GetCachedMobileModByName("OnHitSpellFireballLeechStamina",self.Caster) or 0
		-- leech is a % based mod as long as its higher then 0 and it makes the % chance roll, activate the leeching
		if( lifeLeech >= 1 and math.random(100) <= lifeLeech) then
			local maxHealth = GetMaxHealth(self.Caster)
			local curHealth = GetCurHealth(self.Caster)
			local healAmount = math.ceil(maxHealth * self.LeechEfficacy.Health) or 1
			SetCurHealth(self.Caster,curHealth + healAmount)
		end
		if( manaLeech >= 1 and math.random(100) <= manaLeech) then
			local maxMana = GetMaxMana(self.Caster)
			local curMana = GetCurMana(self.Caster)
			local manaAmount = math.ceil(maxMana * self.LeechEfficacy.Mana) or 1
			SetCurMana(self.Caster,curMana + manaAmount)
		end
		if( staminaLeech >= 1 and math.random(100) <= staminaLeech) then
			local maxStamina = GetMaxStamina(self.Caster)
			local curStamina = GetCurStamina(self.Caster)
			local staminaAmount = math.ceil(maxStamina * self.LeechEfficacy.Stamina) or 1
			SetCurStamina(self.Caster,curStamina + staminaAmount)
		end
	end,	
}