---------------------------------------------------------
-- CAUTERIZE WOUNDS
-- Version 1.0
---------------------------------------------------------
-- removes the bleeding effect from your target
---------------------------------------------------------
SpellData.AllSpells.CauterizeWounds = 
{
	-----------------------------------------------------
	-- General Spell
	-----------------------------------------------------
 	CanBeInterrupted = true,
	CastTime = SpellData.SpellCastTimes.HealNormal,
	Circle = 2,
	SkillTier = SpellData.SpellSkillMinMax.Tier2,
	manaCost = SpellData.SpellManaCost.HealNormal,	
	PowerWords = SpellData.TextColors.PowerWords.Pyromancy .. "Adurendum Vulnera",
	SpellType = "BuffTypeSpell",
	SpellEnabled = true,
	Skill = "PyromancySkill",
	-----------------------------------------------------
	-- Targeting Info
	-----------------------------------------------------
	requireLineOfSight = true,
	TargetRequired = false,
	TargetType = "targetMobile",
	-----------------------------------------------------
	-- Action Button
	-----------------------------------------------------
	Icon = "Immolation",
	SpellDisplayName = "Cauterize Wounds",	
	SpellTooltipString = "Single Target Heal\n[EEEE88][i]\"This spell when casted will cure any target from the bleeding effect on them.\"[/i]\n",
	-----------------------------------------------------	
	-- Casting Effects
	-----------------------------------------------------
	SpellPrimeFXName = "PrimedFire2",
    SpellPrimeFXArgs = "Bone=Ground",
    SpellPrimeFX2Name = "MagicPrimeTrailRedEffect",
    SpellPrimeFX2Args = "Bone=L_Hand",
    SpellPrimedFXName = "MagicPrimeHandRedEffect",
    SpellPrimedFXArgs = "Bone=R_Hand",
    SpellPrimedFX2Name = "MagicPrimeHandRedEffect",
    SpellPrimedFX2Args = "Bone=L_Hand",
	-----------------------------------------------------
	-- Mobile Effects
	-----------------------------------------------------
	MobileEffect = "CauterizeWounds",
	-----------------------------------------------------
	-- Reagents
	-----------------------------------------------------
	Reagents = { "LemonGrass", },
}

---------------------------------------------------------
-- CHAIN EXPLOSION
-- Version 1.0
---------------------------------------------------------
-- chain reaction blast explosive damage on target 
---------------------------------------------------------
SpellData.AllSpells.ChainExplosion = 
{
	-----------------------------------------------------
	-- General Spell
	-----------------------------------------------------
 	CanBeInterrupted = true,
	CastTime = SpellData.SpellCastTimes.DamageHigh,
	Circle = 5,	
	SkillTier = SpellData.SpellSkillMinMax.Tier4,
	manaCost = SpellData.SpellManaCost.DamageHigh,	
	PowerWords = SpellData.TextColors.PowerWords.Pyromancy .. "Catena Crepitus",
	SpellType = "BuffTypeSpell",
	SpellEnabled = true,
	Skill = "PyromancySkill",
	-----------------------------------------------------
	-- Targeting Info
	-----------------------------------------------------
	requireLineOfSight = true,
	TargetRequired = false,
	TargetType = "targetMobile",
	-----------------------------------------------------
	-- Action Button
	-----------------------------------------------------
	Icon = "auraoffire",
	SpellDisplayName = "Chain Explosion",	
	SpellTooltipString = "Single Target Damage\n[EEEE88][i]\"This spell has a delayed effect and causes a series of two explosions to happen every two seconds. Stacking Chain Explosions on a target only resets the the timer. \"[/i]\n",
	-----------------------------------------------------	
	-- Casting Effects
	-----------------------------------------------------
	SpellPrimeFXName = "PrimedFire2",
    SpellPrimeFXArgs = "Bone=Ground",
    SpellPrimeFX2Name = "MagicPrimeTrailRedEffect",
    SpellPrimeFX2Args = "Bone=L_Hand",
    SpellPrimedFXName = "MagicPrimeHandRedEffect",
    SpellPrimedFXArgs = "Bone=R_Hand",
    SpellPrimedFX2Name = "MagicPrimeHandRedEffect",
    SpellPrimedFX2Args = "Bone=L_Hand",
	-----------------------------------------------------
	-- Mobile Effects
	-----------------------------------------------------
	MobileEffect = "ChainExplosion",
	-----------------------------------------------------
	-- Reagents
	-----------------------------------------------------
	Reagents = { "LemonGrass", },
}

---------------------------------------------------------
-- FIREBALL
-- Version 1.0
---------------------------------------------------------
-- fires a FIREBALL at the target dealing damage
---------------------------------------------------------
SpellData.AllSpells.Fireball = nil
SpellData.AllSpells.Fireball = 
{
	-----------------------------------------------------
	-- General Spell
	-----------------------------------------------------
 	CanBeInterrupted = true,
	CastTime = SpellData.SpellCastTimes.DamageNormal,
	Circle = 3,
	SkillTier = SpellData.SpellSkillMinMax.Tier3,
	manaCost = SpellData.SpellManaCost.DamageNormal,	
	PowerWords = SpellData.TextColors.PowerWords.Pyromancy .. "Augue",
	SpellEnabled = true,
	SpellType = "MagicAttackTypeSpell",
	Skill = "PyromancySkill",
	-----------------------------------------------------
	-- Targeting Info
	-----------------------------------------------------
	requireLineOfSight = true,
	TargetRequired = true,
	TargetType = "targetMobile",
	-----------------------------------------------------
	-- Action Button
	-----------------------------------------------------
	Icon = "Fireball",
	SpellDisplayName = "Fireball",	
	SpellTooltipString = "Single Target Damage\n[EEEE88][i]\"This spell hurls a flaming ball of fire at your target.\"[/i]\n",
	-----------------------------------------------------	
	-- Casting Effects
	-----------------------------------------------------
	SpellPrimeFXName = "PrimedFire2",
    SpellPrimeFXArgs = "Bone=Ground",
    SpellPrimeFX2Name = "MagicPrimeTrailRedEffect",
    SpellPrimeFX2Args = "Bone=L_Hand",
    SpellPrimedFXName = "MagicPrimeHandRedEffect",
    SpellPrimedFXArgs = "Bone=R_Hand",
    SpellPrimedFX2Name = "MagicPrimeHandRedEffect",
    SpellPrimedFX2Args = "Bone=L_Hand",
	-----------------------------------------------------	
	-- Projectile Effects
	-----------------------------------------------------	
	SpellTravelEffect = "FireballEffect",
	SpellTravelEffectArgs = "Bone=R_Hand",
	SpellHitEffect = "FireballExplosionEffect",    
	-----------------------------------------------------
	-- Mobile Effects
	-----------------------------------------------------
	TargetMobileEffect = "Fireball",
	-----------------------------------------------------
	-- Reagents
	-----------------------------------------------------
	Reagents = { "LemonGrass", },
}


---------------------------------------------------------
-- FLAMEWHIRL
-- Version 1.0
---------------------------------------------------------
-- fires a puff of fire at the target dealing damage
---------------------------------------------------------
SpellData.AllSpells.FlameWhirl = 
{
	-----------------------------------------------------
	-- General Spell
	-----------------------------------------------------
 	CanBeInterrupted = true,
	CastTime = SpellData.SpellCastTimes.DamageLow,
	Circle = 1,
	SkillTier = SpellData.SpellSkillMinMax.Tier1,
	manaCost = SpellData.SpellManaCost.DamageLow,	
	PowerWords = SpellData.TextColors.PowerWords.Pyromancy .. "Interiore Ignis",
	SpellType = "MagicAttackTypeSpell",
	SpellEnabled = true,
	Skill = "PyromancySkill",
	-----------------------------------------------------
	-- Targeting Info
	-----------------------------------------------------
	requireLineOfSight = true,
	TargetRequired = true,
	TargetType = "targetMobile",
	-----------------------------------------------------
	-- Action Button
	-----------------------------------------------------
	Icon = "Flame Whirl",
	SpellDisplayName = "Flame Whirl",	
	SpellTooltipString = "Single Target Damage\n[EEEE88][i]\"This spell creates a small burning ember that you toss at your target.\"[/i]\n",
	-----------------------------------------------------	
	-- Casting Effects
	-----------------------------------------------------
	SpellPrimeFXName = "PrimedFire2",
    SpellPrimeFXArgs = "Bone=Ground",
    SpellPrimeFX2Name = "FireballEffect",
    SpellPrimeFX2Args = "Bone=L_Hand",
    SpellPrimedFXName = "MagicPrimeHandRedEffect",
    SpellPrimedFXArgs = "Bone=R_Hand",
    SpellPrimedFX2Name = "MagicPrimeHandRedEffect",
    SpellPrimedFX2Args = "Bone=L_Hand",
	-----------------------------------------------------	
	-- Projectile Effects
	-----------------------------------------------------	
	SpellTravelEffect = "FireHeadEffect",
	SpellTravelEffectArgs = "Bone=L_Hand",
	SpellHitEffect = "FireballEffect",    
	-----------------------------------------------------
	-- Mobile Effects
	-----------------------------------------------------
	TargetMobileEffect = "FlameWhirl",
	-----------------------------------------------------
	-- Reagents
	-----------------------------------------------------
	Reagents = { "LemonGrass", },
}

---------------------------------------------------------
-- INNER FIRE
-- Version 1.0
---------------------------------------------------------
-- lose life over time, but gain mana back instead
---------------------------------------------------------
SpellData.AllSpells.InnerFire = 
{
	-----------------------------------------------------
	-- General Spell
	-----------------------------------------------------
 	CanBeInterrupted = true,
	CastTime = SpellData.SpellCastTimes.BuffNormal,
	Circle = 4,
	SkillTier = SpellData.SpellSkillMinMax.Tier3,
	manaCost = SpellData.SpellManaCost.BuffNormal,	
	PowerWords = SpellData.TextColors.PowerWords.Pyromancy .. "Ignis Diaboli",
	SpellType = "BuffTypeSpell",
	SpellEnabled = true,
	Skill = "PyromancySkill",
	-----------------------------------------------------
	-- Targeting Info
	-----------------------------------------------------
	TargetRequired = false,
	TargetType = "TargetSelf",
	-----------------------------------------------------
	-- Action Button
	-----------------------------------------------------
	Icon = "Fire Demon",
	SpellDisplayName = "Inner Fire",	
	SpellTooltipString = "Self Buff\n[EEEE88][i]\"This spell causes you to take damage over time. During this effect you get mana back over time.\"[/i]\n",
	-----------------------------------------------------	
	-- Casting Effects
	-----------------------------------------------------
	SpellPrimeFXName = "PrimedFire2",
    SpellPrimeFXArgs = "Bone=Ground",
    SpellPrimeFX2Name = "MagicPrimeTrailRedEffect",
    SpellPrimeFX2Args = "Bone=L_Hand",
    SpellPrimedFXName = "MagicPrimeHandRedEffect",
    SpellPrimedFXArgs = "Bone=R_Hand",
    SpellPrimedFX2Name = "MagicPrimeHandRedEffect",
    SpellPrimedFX2Args = "Bone=L_Hand",
	-----------------------------------------------------
	-- Mobile Effects
	-----------------------------------------------------
	MobileEffect = "InnerFire",
	-----------------------------------------------------
	-- Reagents
	-----------------------------------------------------
	Reagents = { "LemonGrass", },
}

---------------------------------------------------------
-- Meteor
-- Version 1.0
---------------------------------------------------------
-- drop it like its hot
---------------------------------------------------------
SpellData.AllSpells.Meteor = nil
SpellData.AllSpells.Meteor = 
{
	-----------------------------------------------------
	-- General Spell
	-----------------------------------------------------
 	CanBeInterrupted = true,
	CastTime = SpellData.SpellCastTimes.DamageHigh,
	Circle = 7,
	SkillTier = SpellData.SpellSkillMinMax.Tier5,
	manaCost = SpellData.SpellManaCost.DamageHigh,	
	PowerWords = SpellData.TextColors.PowerWords.Pyromancy .. "Meteorum",
	SpellType = "MagicAttackTypeSpell",
	SpellEnabled = true,
	Skill = "PyromancySkill",
	-----------------------------------------------------
	-- Targeting Info
	-----------------------------------------------------
	TargetRequired = false,
	TargetType = "targetLocation",
	-----------------------------------------------------
	-- Action Button
	-----------------------------------------------------
	Icon = "Hellstorm",
	SpellDisplayName = "Meteor",	
	SpellTooltipString = "Area of Effect Damage\n[EEEE88][i]\"Summons a meteor from the heavens above to rain down upon your target.\"[/i]\n",
	-----------------------------------------------------	
	-- Casting Effects
	-----------------------------------------------------
	SpellPrimeFXName = "PrimedFire2",
    SpellPrimeFXArgs = "Bone=Ground",
    SpellPrimeFX2Name = "MagicPrimeTrailRedEffect",
    SpellPrimeFX2Args = "Bone=L_Hand",
    SpellPrimedFXName = "MagicPrimeHandRedEffect",
    SpellPrimedFXArgs = "Bone=R_Hand",
    SpellPrimedFX2Name = "MagicPrimeHandRedEffect",
    SpellPrimedFX2Args = "Bone=L_Hand",
 --    SpellLaunchSFX = "FallingMeteor",
	-- SpellReleaseUserScript  = "sp_meteor_effect",
	-- DoNotReplaceTarget = true,
	-- InstantHitSpell = true,  
	-----------------------------------------------------
	-- Mobile Effects
	-----------------------------------------------------
	MobileEffect = "Meteor",
	-----------------------------------------------------
	-- Reagents
	-----------------------------------------------------
	Reagents = { "LemonGrass", },
}