-----------------------------------------------------------------------------------------------
-- VERSION 1.0
-----------------------------------------------------------------------------------------------
-- Damage Scaling
-- TODO DAMANGE CHANGE COMMENT CORRECTLY
-- damage = 5 to 25 plus 6-60 (based on skill)
-- RULES
-- 50% less damage to non undead
-----------------------------------------------------------------------------------------------
MobileEffectLibrary.Smite = 
{
	-------------------------------------------------------------------------------------------
	-- CORE VARIABLES
	-------------------------------------------------------------------------------------------
	Duration = SpellData.SpellEffectDuration.Instant,
	MinDamage = 5,
	MaxDamage = 20,
	BaseDamage = 60,
	Caster = nil,
	Target = nil,
	-------------------------------------------------------------------------------------------
	-- CORE FUNCTIONS
	-------------------------------------------------------------------------------------------
	OnEnterState = function(self,root,target,args)
		self.Caster = target
		self.Target = self.ParentObj	
		local baseLightDamage = (GetSkillLevel(self.Caster,"LightMagic")/100) * self.BaseDamage
		local spellDamage = math.random(self.MinDamage,self.MaxDamage) + baseLightDamage
		
		if not(IsUndead(self.Target) or IsDemon(self.Target)) then spellDamage = spellDamage * 0.5 end
		self.Target:SendMessage("DamageInflicted",self.Caster,spellDamage,"MAGIC",false,false,false,self.Caster)
		self.PlayEffects(self,root,target,args)
	end,
	GetPulseFrequency = function(self,root)
		return self.Duration
	end,
	AiPulse = function(self,root)
		EndMobileEffect(root)
	end,
	-------------------------------------------------------------------------------------------
	-- CUSTOM FUNCTIONS
	-------------------------------------------------------------------------------------------
	PlayEffects = function(self,root,target,args)
		self.Target:PlayEffectWithArgs("LightningEffect",2.5,"Bone=Ground")
		if ( self.Target:IsPlayer() ) then
			self.Target:SystemMessage("[FFFF77]Lightning cracks down from the sky, striking you in your tracks...")
		end
	end,
}