---------------------------------------------------------
-- BLESS 
-- Version 1.0
---------------------------------------------------------
-- grants success chance improvment to the target
---------------------------------------------------------
SpellData.AllSpells.Bless = 
{
	-----------------------------------------------------
	-- General Spell
	-----------------------------------------------------
 	CanBeInterrupted = true,
	CastTime = SpellData.SpellCastTimes.BuffNormal,
	Circle = 1,
	SkillTier = SpellData.SpellSkillMinMax.Tier2,
	manaCost = SpellData.SpellManaCost.BuffNormal,	
	PowerWords = SpellData.TextColors.PowerWords.Light .. "Benedicite",
	SpellType = "BuffTypeSpell",
	Skill = "TheologySkill",
	-----------------------------------------------------
	-- Targeting Info
	-----------------------------------------------------
	requireLineOfSight = true,
	TargetRequired = false,
	TargetType = "targetMobile",
	-----------------------------------------------------
	-- Action Button
	-----------------------------------------------------
	Icon = "Healing Hands",
	SpellDisplayName = "Bless",	
	SpellTooltipString = "[CCCC55][b]<[ Bless ]>[/b]\n\n[A9A9A9]Single Target Buff\n\n[EEEE88][i]\"A simple blessing to help inspire your target succeed in everything they do\"[/i]\n",
	-----------------------------------------------------	
	-- Casting Effects
	-----------------------------------------------------
	SpellPrimeFXName = "ConjurePrimeYellowEffect",
    SpellPrimeFXArgs = "Bone=Spine2",
    SpellPrimeFX2Name = "MagicPrimeTrailYellowEffect",
    SpellPrimeFX2Args = "Bone=L_Hand",
    SpellPrimedFXName = "MagicPrimeHandYellowEffect",
    SpellPrimedFXArgs = "Bone=R_Hand",
    SpellPrimedFX2Name = "MagicPrimeHandYellowEffect",
    SpellPrimedFX2Args = "Bone=L_Hand",
	-----------------------------------------------------
	-- Mobile Effects
	-----------------------------------------------------
	MobileEffect = "Bless",
	-----------------------------------------------------
	-- Reagents
	-----------------------------------------------------
	Reagents = { "HolyWater", },
}

---------------------------------------------------------
-- DIVINE AEGIS
-- Version 1.0
---------------------------------------------------------
-- self target buff that gives the user a mobile effect
-- granting them extra defense
---------------------------------------------------------
SpellData.AllSpells.DivineAegis = 
{
	-----------------------------------------------------
	-- General Spell
	-----------------------------------------------------
	CastTime = SpellData.SpellCastTimes.BuffInstant,
	Circle = 4,
	SkillTier = SpellData.SpellSkillMinMax.Tier1,
	manaCost = SpellData.SpellManaCost.BuffShort,	
	PowerWords = SpellData.TextColors.PowerWords.Light .. "Divinus Praesidium",
	SpellType = "BuffTypeSpell",
	Skill = "TheologySkill",
	-----------------------------------------------------
	-- Targeting Info
	-----------------------------------------------------
	TargetRequired = false,
	TargetType = "TargetSelf",
	-----------------------------------------------------
	-- Action Button
	-----------------------------------------------------
	Icon = "Block",
	SpellDisplayName = "Divine Aegis",	
	SpellTooltipString = "[CCCC55][b]<[ Divine Aegis ]>[/b]\n\n[A9A9A9]Self Only Buff\n\n[EEEE88][i]\"A small prayer to the Gods. Instilling you with the protection of the divine world. Giving you courage to march into darkness\"[/i]\n",
	-----------------------------------------------------
	-- Casting Effects
	-----------------------------------------------------
	SpellPrimeFXName = "ConjurePrimeYellowEffect",
    SpellPrimeFXArgs = "Bone=Spine2",
    SpellPrimeFX2Name = "MagicPrimeTrailYellowEffect",
    SpellPrimeFX2Args = "Bone=L_Hand",
    SpellPrimedFXName = "MagicPrimeHandYellowEffect",
    SpellPrimedFXArgs = "Bone=R_Hand",
    SpellPrimedFX2Name = "MagicPrimeHandYellowEffect",
    SpellPrimedFX2Args = "Bone=L_Hand",
	-----------------------------------------------------
	-- Mobile Effects
	-----------------------------------------------------
	MobileEffect = "DivineAegis",
	-----------------------------------------------------
	-- Reagents
	-----------------------------------------------------
	Reagents = { "HolyWater", },
}

---------------------------------------------------------
-- DIVINE FURY
-- Version 1.0
---------------------------------------------------------
-- self target buff that gives the user a mobile effect
-- granting them base damage + attack speed
---------------------------------------------------------
SpellData.AllSpells.DivineFury = 
{
	-----------------------------------------------------
	-- General Spell
	-----------------------------------------------------
	CastTime = SpellData.SpellCastTimes.BuffInstant,
	Circle = 2,
	SkillTier = SpellData.SpellSkillMinMax.Tier3,
	manaCost = SpellData.SpellManaCost.BuffShort,	
	PowerWords = SpellData.TextColors.PowerWords.Light .. "Divinus Furore",
	SpellType = "BuffTypeSpell",
	Skill = "TheologySkill",
	-----------------------------------------------------
	-- Targeting Info
	-----------------------------------------------------
	TargetRequired = false,
	TargetType = "TargetSelf",
	-----------------------------------------------------
	-- Action Button
	-----------------------------------------------------
	Icon = "Ignite",
	SpellDisplayName = "Divine Fury",	
	SpellTooltipString = "[CCCC55][b]<[ Divine Fury ]>[/b]\n\n[A9A9A9]Self Only Buff\n\n[EEEE88][i]\"A small prayer to the Gods. Instilling you with the speed and fury of the Gods. Bestowing great power with in you\"[/i]\n",
	-----------------------------------------------------
	-- Casting Effects
	-----------------------------------------------------
	SpellPrimeFXName = "ConjurePrimeYellowEffect",
    SpellPrimeFXArgs = "Bone=Spine2",
    SpellPrimeFX2Name = "MagicPrimeTrailYellowEffect",
    SpellPrimeFX2Args = "Bone=L_Hand",
    SpellPrimedFXName = "MagicPrimeHandYellowEffect",
    SpellPrimedFXArgs = "Bone=R_Hand",
    SpellPrimedFX2Name = "MagicPrimeHandYellowEffect",
    SpellPrimedFX2Args = "Bone=L_Hand",
	-----------------------------------------------------
	-- Mobile Effects
	-----------------------------------------------------
	MobileEffect = "DivineFury",
	-----------------------------------------------------
	-- Reagents
	-----------------------------------------------------
	Reagents = { "HolyWater", },
}

---------------------------------------------------------
-- HEAL WOUNDS 
-- Version 1.0
---------------------------------------------------------
-- heals your target for a moderate amount
---------------------------------------------------------
SpellData.AllSpells.HealWounds = 
{
	-----------------------------------------------------
	-- General Spell
	-----------------------------------------------------
 	CanBeInterrupted = true,
	CastTime = SpellData.SpellCastTimes.HealHigh,
	Circle = 3,
	SkillTier = SpellData.SpellSkillMinMax.Tier4,
	manaCost = SpellData.SpellManaCost.HealHigh,	
	PowerWords = SpellData.TextColors.PowerWords.Light .. "Sana Vulnere",
	SpellType = "BuffTypeSpell",
	Skill = "TheologySkill",
	-----------------------------------------------------
	-- Targeting Info
	-----------------------------------------------------
	requireLineOfSight = true,
	TargetRequired = false,
	TargetType = "targetMobile",
	-----------------------------------------------------
	-- Action Button
	-----------------------------------------------------
	Icon = "restore",
	SpellDisplayName = "Heal Wounds",	
	SpellTooltipString = "[CCCC55][b]<[ Heal Wounds ]>[/b]\n\n[A9A9A9]Single Target Heal\n\n[EEEE88][i]\"Channel your faith in the light to restore the health of your target\"[/i]\n",
	-----------------------------------------------------
	-- Casting Effects
	-----------------------------------------------------
	SpellPrimeFXName = "ConjurePrimeYellowEffect",
    SpellPrimeFXArgs = "Bone=Spine2",
    SpellPrimeFX2Name = "MagicPrimeTrailYellowEffect",
    SpellPrimeFX2Args = "Bone=L_Hand",
    SpellPrimedFXName = "MagicPrimeHandYellowEffect",
    SpellPrimedFXArgs = "Bone=R_Hand",
    SpellPrimedFX2Name = "MagicPrimeHandYellowEffect",
    SpellPrimedFX2Args = "Bone=L_Hand",
	-----------------------------------------------------
	-- Mobile Effects
	-----------------------------------------------------
	MobileEffect = "HealWounds",
	-----------------------------------------------------
	-- Reagents
	-----------------------------------------------------
	Reagents = { "HolyWater", },
}

---------------------------------------------------------
-- HEALING WORD 
-- Version 1.0
---------------------------------------------------------
-- heal others around you for a little amount
---------------------------------------------------------
SpellData.AllSpells.HealingWord = 
{
	-----------------------------------------------------
	-- General Spell
	-----------------------------------------------------
 	CanBeInterrupted = true,
	CastTime = SpellData.SpellCastTimes.HealNormal,
	Circle = 6,
	SkillTier = SpellData.SpellSkillMinMax.Tier4,
	manaCost = SpellData.SpellManaCost.HealNormal,	
	PowerWords = SpellData.TextColors.PowerWords.Light .. "Sanitatem Verbum",
	SpellType = "BuffTypeSpell",
	Skill = "TheologySkill",
	SpellEnabled = false,
	-----------------------------------------------------
	-- Targeting Info
	-----------------------------------------------------
	TargetRequired = false,
	TargetType = "TargetSelf",
	-----------------------------------------------------
	-- Action Button
	-----------------------------------------------------
	Icon = "Divine Aura 01",
	SpellDisplayName = "Healing Word",	
	SpellTooltipString = "[CCCC55][b]<[ Healing Word ]>[/b]\n\n[A9A9A9]Area of Effect Heal\n\n[EEEE88][i]\"Shout the word of the light, healing nearby allies.\"[/i]\n",
	-----------------------------------------------------	
	-- Casting Effects
	-----------------------------------------------------
	SpellPrimeFXName = "ConjurePrimeYellowEffect",
    SpellPrimeFXArgs = "Bone=Spine2",
    SpellPrimeFX2Name = "MagicPrimeTrailYellowEffect",
    SpellPrimeFX2Args = "Bone=L_Hand",
    SpellPrimedFXName = "MagicPrimeHandYellowEffect",
    SpellPrimedFXArgs = "Bone=R_Hand",
    SpellPrimedFX2Name = "MagicPrimeHandYellowEffect",
    SpellPrimedFX2Args = "Bone=L_Hand",
	-----------------------------------------------------
	-- Mobile Effects
	-----------------------------------------------------
	MobileEffect = "HealingWord",
	-----------------------------------------------------
	-- Reagents
	-----------------------------------------------------
	Reagents = { "HolyWater", },
}

---------------------------------------------------------
-- SMITE 
-- Version 1.0
---------------------------------------------------------
-- damages your target, more damage vs demons and undead
---------------------------------------------------------
SpellData.AllSpells.Smite = 
{
	-----------------------------------------------------
	-- General Spell
	-----------------------------------------------------
 	CanBeInterrupted = true,
	CastTime = SpellData.SpellCastTimes.DamageHigh,
	Circle = 5,
	SkillTier = SpellData.SpellSkillMinMax.Tier5,
	manaCost = SpellData.SpellManaCost.DamageNormal,	
	PowerWords = SpellData.TextColors.PowerWords.Light .. "Percutite",
	SpellType = "BuffTypeSpell",
	Skill = "TheologySkill",
	-----------------------------------------------------
	-- Targeting Info
	-----------------------------------------------------
	requireLineOfSight = true,
	TargetRequired = false,
	TargetType = "targetMobile",
	-----------------------------------------------------
	-- Action Button
	-----------------------------------------------------
	Icon = "Imbue Holy",
	SpellDisplayName = "Smite",	
	SpellTooltipString = "[CCCC55][b]<[ Smite ]>[/b]\n\n[A9A9A9]Single Target Damage\n\n[EEEE88][i]\"Smite your target with holy light.\"[/i]\n",
	-----------------------------------------------------	
	-- Casting Effects
	-----------------------------------------------------
	SpellPrimeFXName = "ConjurePrimeYellowEffect",
    SpellPrimeFXArgs = "Bone=Spine2",
    SpellPrimeFX2Name = "MagicPrimeTrailYellowEffect",
    SpellPrimeFX2Args = "Bone=L_Hand",
    SpellPrimedFXName = "MagicPrimeHandYellowEffect",
    SpellPrimedFXArgs = "Bone=R_Hand",
    SpellPrimedFX2Name = "MagicPrimeHandYellowEffect",
    SpellPrimedFX2Args = "Bone=L_Hand",
	-----------------------------------------------------
	-- Mobile Effects
	-----------------------------------------------------
	MobileEffect = "Smite",
	-----------------------------------------------------
	-- Reagents
	-----------------------------------------------------
	Reagents = { "HolyWater", },
}
